//---------------------------------------------------------------------------

#include <vcl.h>
#pragma hdrstop

#include "attack/attack.h"
#include "ia/fighters.h"

#include "plane/plane.h"
#include "zrk/f_zrk.h"
#include "zrk/zrk.h"

#include "rls/f_rls.h"
#include "objects/f_obj.h"
#include "advance/f_add.h"
#include "main.h"
//#include  ""
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma resource "*.dfm"

// Global Variables
double SPEED_COEF=360;
planes current_attack_bomb,default_attack_bomb;
planes current_attack_fighter,default_attack_fighter;
planes current_defence_fighter,default_defence_fighter;
ZRK current_zrk_mon,default_zrk_mon;
ZRK current_zrk_mult,default_zrk_mult;
RLS current_rls,default_rls;
rls rls_var;
target objects[7],def_objects[7];
 int victory;
 int attack_brockets;			// bombs & rockets quantity on board
 int attack_irockets; 		// bombs & rockets quantity on board
 double rls_radius;
 double cur_time,dt;
 double attack_averagetakeofftime;
 double attack_tpike,def_tpike; // maneuver time
 int attack_sopr; // fighters to each bomber
 int attack_bnum; // start quantity of Bombers
 int attack_inum;
 int intercept_num; // start quantity of Fighters
 double attack_rad_sopr; 	// km	// Radius of Fighter escort of Bomber SUGGESSION: rename Attack_escort_radius
 double t_zaderjka,def_zaderjka;            //      	// consts for returning to base
 double t_polomki,def_polomki;               //      	// consts for returning to base
 double t_perezar,def_perezar;             //      	// consts for returning to base
 double t_toplivo,def_toplivo;		// 	// consts for returning to base

TMain_form *Main_form;
is_loaded is_load=is_loaded();
init_strucs_from_file init;
CAirports air;
//// - End of Global Vars ----

//---------------------------------------------------------------------------
__fastcall TMain_form::TMain_form(TComponent* Owner)
        : TForm(Owner)
{
}
//------------------------------------------------------------------------
Graphics::TBitmap * TMain_form::enviroment(double coeff)
{

Graphics::TBitmap *Area=new Graphics::TBitmap();
Area->Height=field->Height;
Area->Width=field->Width;

Area->Canvas->Pen->Color=clGreen;
//                     rls
Area->Canvas->Ellipse(abs_coord[0].x-f_obj_rad,abs_coord[0].y-f_obj_rad, \
abs_coord[0].x+f_obj_rad,abs_coord[0].y+f_obj_rad);

Area->Canvas->TextOutA(1*abs_coord[0].x-(2*Area->Canvas->TextWidth("TT")/3)-1, \
abs_coord[0].y-Area->Canvas->TextHeight("T")/2, \
"");
//                  zrk1
Area->Canvas->Ellipse(-f_obj_rad+abs_coord[tt_ZRK_mon].x*1, \
-f_obj_rad+abs_coord[tt_ZRK_mon].y, \
f_obj_rad+abs_coord[tt_ZRK_mon].x*1,  \
+f_obj_rad+abs_coord[tt_ZRK_mon].y);

Area->Canvas->TextOutA(-(Area->Canvas->TextWidth("TT"))+abs_coord[tt_ZRK_mon].x*1, \
-Area->Canvas->TextHeight("T")/2+abs_coord[tt_ZRK_mon].y, \
"1");
//===========================2
Area->Canvas->Ellipse(-f_obj_rad+abs_coord[tt_ZRK_mult].x*1,\
-f_obj_rad+abs_coord[tt_ZRK_mult].y, \
+f_obj_rad+abs_coord[tt_ZRK_mult].x*1, \
+f_obj_rad+abs_coord[tt_ZRK_mult].y);

Area->Canvas->TextOutA(-(Area->Canvas->TextWidth("TT"))-1+abs_coord[tt_ZRK_mult].x*1, \
-Area->Canvas->TextHeight("T")/2+abs_coord[tt_ZRK_mult].y, \
"2");
//-----------------------------
Area->Canvas->Rectangle(-obj_size.x+abs_coord[tt_OBJ].x*1,\
-obj_size.y+abs_coord[tt_OBJ].y, \
+obj_size.x+abs_coord[tt_OBJ].x*1,  \
+obj_size.y+abs_coord[tt_OBJ].y);

Area->Canvas->TextOutA(-(3*Area->Canvas->TextWidth("T"))-1+abs_coord[tt_OBJ].x*1, \
-Area->Canvas->TextHeight("T")/2+abs_coord[tt_OBJ].y, \
"");
//,..............................
Area->Canvas->Ellipse(-f_obj_rad+abs_coord[tt_IA_home].x*1,  \
-f_obj_rad+abs_coord[tt_IA_home].y, \
+f_obj_rad+abs_coord[tt_IA_home].x*1, \
+f_obj_rad+abs_coord[tt_IA_home].y);

Area->Canvas->TextOutA(-(Area->Canvas->TextWidth("TT")/3)-1+abs_coord[tt_IA_home].x*1, \
-Area->Canvas->TextHeight("T")/2+abs_coord[tt_IA_home].y, \
"");

Area->Canvas->Pen->Color=clRed;

//..............................
Area->Canvas->Ellipse(-f_obj_rad+abs_coord[tt_BOMB_attack].x*1, \
-f_obj_rad+abs_coord[tt_BOMB_attack].y, \
+f_obj_rad+abs_coord[tt_BOMB_attack].x*1,  \
+f_obj_rad+abs_coord[tt_BOMB_attack].y);

Area->Canvas->TextOutA(+abs_coord[tt_BOMB_attack].x*1+f_obj_rad-Area->Canvas->TextWidth("T"), \
-Area->Canvas->TextHeight("T")/2+abs_coord[tt_BOMB_attack].y, \
"");
//...............................

Area->Canvas->Ellipse(-f_obj_rad+abs_coord[tt_IA_attack].x*1, \
-f_obj_rad+abs_coord[tt_IA_attack].y, \
+f_obj_rad+abs_coord[tt_IA_attack].x*1, \
+f_obj_rad+abs_coord[tt_IA_attack].y);

Area->Canvas->TextOutA(+abs_coord[tt_IA_attack].x*1+f_obj_rad-Area->Canvas->TextWidth("T"), \
-Area->Canvas->TextHeight("T")/2+abs_coord[tt_IA_attack].y, \
"");
//------------------------------------------------------
//------------------    
 Area->Canvas->Pen->Style=psDash;
 Area->Canvas->Brush->Style=bsClear;
 Area->Canvas->Pen->Color=clGreen;
 //.......................            RLS
 Area->Canvas->Ellipse(abs_coord[0].x-current_rls.radius*coeff,\
1*(abs_coord[0].y-current_rls.radius), \
1*(abs_coord[0].x+current_rls.radius*coeff),\
1*(abs_coord[0].y+current_rls.radius));
  //........................              ZRK1
Area->Canvas->Ellipse(abs_coord[tt_ZRK_mon].x-current_zrk_mon.Lmax*coeff,\
abs_coord[1].y-current_zrk_mon.Lmax, \
abs_coord[1].x+current_zrk_mon.Lmax*coeff,\
abs_coord[1].y+current_zrk_mon.Lmax);
    //.....................               ZRK2
Area->Canvas->Ellipse(abs_coord[tt_ZRK_mult].x-current_zrk_mult.Lmax*coeff,\
abs_coord[2].y-current_zrk_mult.Lmax, \
abs_coord[2].x+current_zrk_mult.Lmax*coeff,\
abs_coord[2].y+current_zrk_mult.Lmax);
//..................................IA
Area->Canvas->Ellipse(abs_coord[3].x-current_defence_fighter.radius*coeff,\
abs_coord[3].y-current_defence_fighter.radius, \
abs_coord[3].x+current_defence_fighter.radius*coeff,\
abs_coord[3].y+current_defence_fighter.radius);

//..................................Attack
Area->Canvas->Pen->Color=clRed;
Area->Canvas->Ellipse( \
abs_coord[5].x-current_defence_fighter.radius*coeff,\
abs_coord[5].y-current_attack_fighter.radius, \
abs_coord[5].x+current_attack_fighter.radius*coeff,\
abs_coord[5].y+current_attack_fighter.radius);

Area->Canvas->Ellipse( \
abs_coord[6].x-current_attack_bomb.radius*coeff,\
abs_coord[6].y-current_attack_bomb.radius, \
abs_coord[6].x+current_attack_bomb.radius*coeff,\
abs_coord[6].y+current_attack_bomb.radius);


  return Area;
}
//---------------------------------------------------------------------------
void __fastcall TMain_form::b_zrkClick(TObject *Sender)
{

if(! is_load.zrk)
 {
 form_zrk->Load_to_form_zrk(default_zrk_mon);
  is_load.zrk=true;

 }
 else
 {
  form_zrk->zrk_tab->TabIndex=0;
  form_zrk->Load_to_form_zrk(current_zrk_mon);
  }
form_zrk->Show();
}
//---------------------------------------------------------------------------
void __fastcall TMain_form::b_rlsClick(TObject *Sender)
{
if(! is_load.rls)
 {
 form_rls->Load_to_form_rls(default_rls);
  is_load.rls=true;

 }
 else
 form_rls->Load_to_form_rls(current_rls);

 form_rls->Show();
}
//---------------------------------------------------------------------------
void __fastcall TMain_form::b_atack_fightClick(TObject *Sender)
{

 if(! is_load.fighter)
 {
  form_plane->Tag=tt_IA_attack;
 form_plane->Load_to_form_planes(default_attack_fighter);
  is_load.fighter=true;

 }
 else
  form_plane->Load_to_form_planes(current_attack_fighter);


  form_plane->Tag=tt_IA_attack;
  form_plane->Show();
}
//---------------------------------------------------------------------------
void __fastcall TMain_form::b_attack_bombClick(TObject *Sender)
{
if(! is_load.bomb)
 {
  form_plane->Tag=tt_BOMB_attack;
  form_plane->Load_to_form_planes(default_attack_bomb);
  is_load.bomb=true;
 }
 else

  form_plane->Load_to_form_planes(current_attack_bomb);

  form_plane->Tag=tt_BOMB_attack;
form_plane->Show();

}
//---------------------------------------------------------------------------
void __fastcall TMain_form::b_iaClick(TObject *Sender)
{
if(! is_load.ia)
 {
  form_plane->Tag=tt_IA_home;
form_plane->Load_to_form_planes(default_defence_fighter);
  is_load.ia=true;
 }
 else
  form_plane->Load_to_form_planes(current_defence_fighter);

  form_plane->Tag=tt_IA_home;
  form_plane->Show();
}
//---------------------------------------------------------------------------
void __fastcall TMain_form::b_exitClick(TObject *Sender)
{
Main_form->Close();
}
//---------------------------------------------------------------------------


void __fastcall TMain_form::b_coordClick(TObject *Sender)
{
if(!is_load.obj)
{
form_obj->obj_tab->TabIndex=0;
form_obj->Load_to_form_obj(def_objects[0]);
is_load.obj=true;
}
else
{
form_obj->obj_tab->TabIndex=0;
form_obj->Load_to_form_obj(objects[form_obj->obj_tab->TabIndex]);
}

form_obj->Show();

}

//==============================INITIAL
void __fastcall TMain_form::FormCreate(TObject *Sender)
{
 Model=new Graphics::TBitmap();

//  
try{
Model->LoadFromFile("pic.bmp");
   }
 catch(...){
MessageBox(NULL,"   !","Error",mb_illegal);
 delete Model;
 exit(0);
 }
victory=0;
if((init.f=fopen("init.ini","r+"))==NULL)
   {
MessageBox(NULL,"  !","Error",mb_illegal);
 exit(0) ;
 }
  init.str_miss();
//Init bulding
for(int i=0;i<7;i++)
{
 init.str_miss();
 init.Load_objects(def_objects[i]);
 objects[i]=def_objects[i];
}
init.str_miss();
init.str_miss();
init.Load_planes(current_attack_bomb);
init.str_miss();
init.Load_planes(current_attack_fighter);
init.str_miss();
init.Load_planes(current_defence_fighter);
init.str_miss();
init.str_miss();
init.Load_zrk(current_zrk_mon);
init.str_miss();
init.Load_zrk(current_zrk_mult);
init.str_miss();
init.Load_rls(current_rls);
init.str_miss();
init.Load_adv_atack();

me_bomb->Text=String(attack_bnum);
me_fighter->Text=String(attack_inum);

default_attack_bomb=current_attack_bomb;
default_attack_fighter=current_attack_fighter;
default_defence_fighter=current_defence_fighter;
default_zrk_mon=current_zrk_mon;
default_zrk_mult=current_zrk_mult;
default_rls=current_rls;


}
//---------------------------------------------------------------------------

void __fastcall TMain_form::add_parClick(TObject *Sender)
{
f_addpar->Load_to_form_add();
f_addpar->Show();
}
//---------------------------------------------------------------------------

void __fastcall TMain_form::b_startClick(TObject *Sender)
{
        int minx=0,maxx=0,maxx_i=0;
//  
//obj_size.x == 
// obj_size.y==

        attack_vector_group.clear();
        attack_vector_air.clear();
        air.listFighters.clear();
        rls_var.masTraekt.clear();

        obj_size=Point(30,20);
        f_obj_rad=20;
        expand_coeff=0;

        SPEED_COEF=me_coeff->Text.ToDouble();
      if(SPEED_COEF<1)
      {
MessageBox(NULL,"     .","Error",mb_illegal);
return;
       }
       SPEED_COEF=360/SPEED_COEF;
        field->Left=0;
        field->Top=0;
        field->Height=ClientHeight;
        abs_coord[0]=Point((17*field->Width)/24,ClientHeight/2);

        for(int i=0;i<7;i++)
        {
                if(objects[i].x<minx)minx=objects[i].x;
                if(objects[i].x>maxx)
                {
                        maxx=objects[i].x;  maxx_i=i;
                }
        }

        //  --------------------   
        if(abs(maxx)+abs(minx))
        expand_coeff=(double)field->Width/(abs(maxx)+abs(minx)+1*f_obj_rad);
        if(expand_coeff>1)
        expand_coeff=1;
        abs_coord[0].x=field->Width-expand_coeff*maxx \
                        -(maxx_i==tt_OBJ?obj_size.x:f_obj_rad);

        //................................  (. ) 
        for(int i=1;i<7;i++)
        {
                abs_coord[i].x=abs_coord[0].x+expand_coeff*objects[i].x;
                abs_coord[i].y=abs_coord[0].y+objects[i].y;
        }

        //    
        if(is_load.was_started)
        {
                if(!is_load.zrk)
                {
                        current_zrk_mon=default_zrk_mon;
                        current_zrk_mult=default_zrk_mult;
                }
                if(!is_load.obj)
                        for(int ind=0;ind<7;ind++)
                                objects[ind]=def_objects[ind];
        }

        is_load.was_started=true;
        is_load.all_false();

        b_stop->Caption="";
        attack_bnum=me_bomb->Text.ToDouble();
        attack_inum=me_fighter->Text.ToDouble();
        intercept_num=me_intercept->Text.ToDouble();
        attack_brockets=current_attack_bomb.weapon;
        attack_irockets=current_attack_fighter.weapon;
        rls_radius=current_rls.radius;
        //      
        visible.resize(attack_bnum+attack_inum,false);
        h_show.resize(attack_bnum+attack_inum,false);
        //                                  

        dt=(double)(current_rls.period/SPEED_COEF);
        attack_tpike=(double)def_tpike/SPEED_COEF;
        t_zaderjka=(double)def_zaderjka/SPEED_COEF;
        t_polomki=(double)def_polomki/SPEED_COEF;
        t_perezar=(double)def_perezar/SPEED_COEF;
        t_toplivo=(double)def_toplivo/SPEED_COEF;
         cur_time=0;
         randomize();
        //========================================
//-----------------------------   
Attack_Init();
rls_var.rls_init();
air.Defence_Init(intercept_num);
zrk_init();
//....................................................
 //  
 Area=new Graphics::TBitmap();
 Temp=new Graphics::TBitmap();

 model_coord[m_off_plane]=Rect(0,0,22,22); //+24
 model_coord[m_off_plane_v]=Rect(24,0,46,22);
 model_coord[m_def_plane]=Rect(48,0,70,22);
 model_coord[m_rocket]=Rect(72,0,84,10);


Temp->Width=field->Width;
Temp->Height=field->Height;

Area->Width=field->Width;
Area->Height=field->Height;

Area->Dormant();
Temp->Dormant();
Model->Dormant();
//             

Area=enviroment(expand_coeff);
field->Canvas->Draw(0,0,Area);
timer->Interval=100;
timer->Enabled=true;
b_stop->Enabled=true;
}
//---------------------------------------------------------------------------

void __fastcall TMain_form::timerTimer(TObject *Sender)
{
int i,num_coord=m_off_plane;
list<CFighters>::iterator pointer;
// 

timer->Enabled=false;
Temp->Canvas->CopyMode=cmSrcCopy;
Temp->Canvas->CopyRect(Rect(0,0,Area->Width,Area->Height),Area->Canvas, \
Rect(0,0,Area->Width,Area->Height));
 info_out();

on_base[0]=attack_inum;
on_base[1]=attack_bnum;
on_base[2]=intercept_num;
alive[0]=0;
alive[1]=0;
alive[2]=0;

switch(i=Attack())
 {
case(-1):info_out();MessageBox(NULL,"  ","",mb_illegal);
                 return;
 case(-2): info_out();MessageBox(NULL,"      ","",mb_illegal);
                 return;
 case(-3):  info_out();MessageBox(NULL,"        ","",mb_illegal);
                 return;
 case(-4):  MessageBox(NULL,"     \n  \n\
    ","",mb_illegal);
                 return;
}
//..................................... 
if(objects[0].life>0)
   rls_var.one_takt();
  else
{
info_out();
MessageBox(NULL," .","",mb_illegal);
return;
}

shot();
air.Tact();


   for(i=0;i<attack_vector_air.size();i++)
   {
        if(attack_vector_air[i].life<=0)
                on_base[attack_vector_air[i].type]--;
        if(objects[0].life>0)
                visible[i]=rls_var.is_view(i);
        else
                visible[i]=false;

        if( (is_attack_onair(attack_vector_air[i]))&&(attack_vector_air[i].life>0))
        {
                num_coord=visible[i] ? m_off_plane_v : m_off_plane;
                //  
                 alive[attack_vector_air[i].type]++;
                on_base[attack_vector_air[i].type]--;
                //   ,   
                Temp->Canvas->CopyMode=cmSrcAnd;
                // 
                if(h_show[i])
                {
                        Temp->Canvas->TextOutA(attack_vector_air[i].x*expand_coeff+abs_coord[0].x-plane_mash, \
                                attack_vector_air[i].y+abs_coord[0].y-plane_mash-Temp->Canvas->TextHeight("9"),\
                                "h:"+String((int)(1000*attack_vector_air[i].h)));

                        Temp->Canvas->TextOutA(attack_vector_air[i].x*expand_coeff+abs_coord[0].x-plane_mash, \
                                attack_vector_air[i].y+abs_coord[0].y+plane_mash,\
                                "v:"+String((int)attack_vector_air[i].v));

                }

                Temp->Canvas->CopyRect(  \
                        Rect((attack_vector_air[i].x*expand_coeff+abs_coord[0].x-plane_mash),\
                        ( attack_vector_air[i].y+abs_coord[0].y-plane_mash), \
                        (attack_vector_air[i].x*expand_coeff+abs_coord[0].x+plane_mash), \
                        ( attack_vector_air[i].y+abs_coord[0].y+plane_mash) ), \
                        Model->Canvas, \
                        model_coord[num_coord]
                      ) ;
        }

        //end if
        else  {
                 visible[i]=false;
                 h_show[i]=false;
        }
    } //end for

 if(on_base[1]+alive[1]==0)
 {
 info_out();
Application->MessageBoxA("  .","",mb_illegal);
return;
 }
 if(objects[1].life+objects[2].life+objects[3].life==0)
 {
 info_out();
Application->MessageBoxA("   ","",mb_illegal);
return;

 }
    for(pointer=air.listFighters.begin();pointer!=air.listFighters.end();pointer++)
    {
        if(pointer->h!=0)
        {
                on_base[2]--;
                Temp->Canvas->CopyRect(  \
                        Rect( (pointer->x*expand_coeff+abs_coord[0].x-plane_mash),\
                                ( pointer->y+abs_coord[0].y-plane_mash), \
                                (pointer->x*expand_coeff+abs_coord[0].x+plane_mash), \
                                ( pointer->y+abs_coord[0].y+plane_mash)
                             ), \
                        Model->Canvas, \
                        model_coord[m_def_plane] \
                      ) ;
         } //end if
    alive[2]++;
   }   //end for
//  if(!((ZRK1.disposition).x==objects[2].x && ZRK1.disposition.y==objects[2].y))
  // if(ZRK1.disposition.z!=0)   ZRK1.Channels[i].pos_rocket.x

for (int k = 0; k<current_zrk_mult.Rock_Chan;k++)
//if(ZRK1.Channels[i].pos_rocket.z>0)
    if( (ZRK1.Channels[k].pos_rocket.x || ZRK1.Channels[k].pos_rocket.y) && current_zrk_mult.Capacity)
        Temp->Canvas->CopyRect(  \
                        Rect( (ZRK1.Channels[k].pos_rocket.x*expand_coeff+abs_coord[0].x-rocket_mash),\
                                ( ZRK1.Channels[k].pos_rocket.y+abs_coord[0].y-rocket_mash), \
                                (ZRK1.Channels[k].pos_rocket.x*expand_coeff+abs_coord[0].x+rocket_mash), \
                                ( ZRK1.Channels[k].pos_rocket.y+abs_coord[0].y+rocket_mash)
                             ), \
                        Model->Canvas, \
                        model_coord[m_rocket] \
                      ) ;

// if(!(ZRK2.disposition.x==objects[1].x && ZRK2.disposition.y==objects[1].y))
  // if(ZRK2.Channels[0].pos_rocket.z>0)
for (int k = 0; k<current_zrk_mon.Rock_Chan;k++)
    if( (ZRK2.Channels[k].pos_rocket.x || ZRK2.Channels[k].pos_rocket.y) && current_zrk_mon.Capacity)
        Temp->Canvas->CopyRect(  \
                        Rect( (ZRK2.Channels[k].pos_rocket.x*expand_coeff+abs_coord[0].x-rocket_mash),\
                                ( ZRK2.Channels[k].pos_rocket.y+abs_coord[0].y-rocket_mash), \
                                (ZRK2.Channels[k].pos_rocket.x*expand_coeff+abs_coord[0].x+rocket_mash), \
                                ( ZRK2.Channels[k].pos_rocket.y+abs_coord[0].y+rocket_mash)
                             ), \
                        Model->Canvas, \
                        model_coord[m_rocket] \
                      ) ;

  cur_time += dt;

  field->Canvas->Draw(0,0,Temp);
  timer->Enabled=true;

}
//---------------------------------------------------------------------------

void __fastcall TMain_form::b_stopClick(TObject *Sender)
{
        timer->Enabled=!timer->Enabled;
        b_stop->Caption=timer->Enabled?"":"";
}
//---------------------------------------------------------------------------


void __fastcall TMain_form::fieldMouseDown(TObject *Sender,
      TMouseButton Button, TShiftState Shift, int X, int Y)
{
for(int i=0;i<attack_vector_air.size();i++)
{

if((attack_vector_air[i].x*expand_coeff-plane_mash+abs_coord[0].x<X) && \
 (X<attack_vector_air[i].x*expand_coeff+plane_mash+abs_coord[0].x)&& \
 (Y<attack_vector_air[i].y+plane_mash+abs_coord[0].y)   \
  && (Y>attack_vector_air[i].y-plane_mash+abs_coord[0].y))
   {
    if(h_show.size())
     h_show[i]=!h_show[i];
    }
 }
}
//---------------------------------------------------------------------------
//...............
//       Info out

void   TMain_form::info_out()
{
TPoint coord,offset;

for(int i=0;i<7;i++)
{
coord=abs_coord[i];
 offset=(i!=tt_OBJ)?Point(f_obj_rad,f_obj_rad):obj_size;
 if(coord.x+Temp->Canvas->TextWidth(":") > Temp->Width)
 coord.x-=Temp->Canvas->TextWidth(":");
 if (coord.x+Temp->Canvas->TextWidth(":") < 0)
  coord.x+=Temp->Canvas->TextWidth(":");
  coord.y+=offset.y/2+1+Temp->Canvas->TextHeight("X");

Temp->Canvas->TextOutA(coord.x,coord.y,String(":")+String(objects[i].life));
     coord.y+=Temp->Canvas->TextHeight("X");
Temp->Canvas->TextOutA(coord.x,coord.y,String(":")+String(objects[i].importance));
coord.y+=Temp->Canvas->TextHeight("X");
if(i==3)
{
Temp->Canvas->TextOutA(coord.x,coord.y,String(":")+String(on_base[2]));
coord.y+=Temp->Canvas->TextHeight("X");
Temp->Canvas->TextOutA(coord.x,coord.y,String(":")+String(alive[2]));
}
if(i>4)
{
Temp->Canvas->TextOutA(coord.x,coord.y,String(":")+String(on_base[6-i]));
coord.y+=Temp->Canvas->TextHeight("X");

Temp->Canvas->TextOutA(coord.x,coord.y,String(":")+String(on_base[6-i]+alive[6-i]));
}
if(i==1)
Temp->Canvas->TextOutA(coord.x,coord.y,String(":")+String(current_zrk_mon.Capacity));
if(i==2)
Temp->Canvas->TextOutA(coord.x,coord.y,String(":")+String(current_zrk_mult.Capacity));
}

}
  is_loaded::is_loaded()
  {
  bomb=false;
  ia=false;
  fighter=false;
  rls=false;
  zrk=false;
  add=false;
  obj=false;
  was_started=false;
  };

void is_loaded::all_false()
  {
  bomb=false;   ia=false;
  fighter=false; rls=false;
  zrk=false; add=false;
  obj=false;
  };

//---------------------------------------------------------------------------
void  init_strucs_from_file::Load_objects(target &cur)
{
fscanf(f,"%i%lf%lf%i%i",&cur.target_type,&cur.x,&cur.y,&cur.life,&cur.importance);
}

void init_strucs_from_file::Load_planes(planes &cur)
{
fscanf(f,"%lf%lf%lf%lf%lf",&cur.Vmin,&cur.Vmax,&cur.Vcruise,&cur.Hmin,&cur.Hmax);
fscanf(f,"%lf%i%lf%lf",&cur.Hoptimal,&cur.weapon,&cur.pr,&cur.radius);
}

void init_strucs_from_file::Load_zrk(ZRK &cur)
{
fscanf(f,"%lf%lf%lf%lf%lf",&cur.Lmin,&cur.Lmax,&cur.Hmin,&cur.Hmax,&cur.D_radius);
fscanf(f,"%lf%lf%i%i%i%i", \
&cur.Vmax,&cur.Pr,&cur.Targ_Chan,&cur.Rock_Chan,&cur.Fire_Density,&cur.Capacity);
}

void init_strucs_from_file::Load_rls(RLS &cur)
{
 fscanf(f,"%lf%lf%lf%lf%lf%lf%lf%lf%lf%lf", \
&cur.Lminhigh,&cur.Lmax,&cur.Lmaxlow,&cur.Lminhigh,&cur.Hmin,&cur.Hminfar,&cur.Hmax, \
&cur.radius,&cur.period,&cur.Eps);
}

void init_strucs_from_file::Load_adv_atack()
{
fscanf(f,"%i%i%i%lf%lf%lf%lf%lf%lf%lf",               \
 &attack_sopr, &attack_bnum, &attack_inum, \
 &attack_averagetakeofftime,&def_tpike,&attack_rad_sopr, \
 &def_zaderjka,&def_polomki,&def_perezar,&def_toplivo);
}

void init_strucs_from_file::str_miss()
{
fscanf(f,"%s",str);
}

//---------------------------------------------------------------------------

