//---------------------------------------------------------------------------
#ifndef mainH
#define mainH
//---------------------------------------------------------------------------
#include <Classes.hpp>
#include <Controls.hpp>
#include <StdCtrls.hpp>
#include <Forms.hpp>
#include <Mask.hpp>
#include "global.h"
#include "rls\rls.h"


#include <ExtCtrls.hpp>
#define m_off_plane 0
#define m_off_plane_v 1
#define m_def_plane 2
#define m_rocket 3
#define rocket_mash 5
#define plane_mash 10
//.........................................
//===============================================================
                        //Initialize extern variables

//planes current_attack_bomb,default_attack_bomb;
//planes current_attack_fighter,default_attack_fighter;
//planes current_defence_fighter,default_defence_fighter;
//ZRK current_zrk_mon,default_zrk_mon;
//ZRK current_zrk_mult,default_zrk_mult;
//RLS current_rls,default_rls;
//vector <attack_group> attack_vector_group;
//vector <attack_air> attack_vector_air;

//---------------------------------------------------------------------------

class TMain_form : public TForm
{
__published:	// IDE-managed Components
        TGroupBox *GroupBox1;
        TButton *b_atack_fight;
        TButton *b_attack_bomb;
        TGroupBox *gb_def;
        TButton *b_rls;
        TButton *b_zrk;
        TButton *b_ia;
        TButton *b_exit;
        TButton *b_start;
        TLabel *Label1;
        TLabel *Label2;
        TLabel *Label3;
        TMaskEdit *me_bomb;
        TMaskEdit *me_fighter;
        TMaskEdit *me_intercept;
        TGroupBox *GroupBox2;
        TButton *b_coord;
        TButton *add_par;
        TImage *field;
        TButton *b_stop;
        TTimer *timer;
        TMaskEdit *me_coeff;
        TLabel *Label4;

        void __fastcall b_zrkClick(TObject *Sender);
        void __fastcall b_rlsClick(TObject *Sender);
        void __fastcall b_atack_fightClick(TObject *Sender);
        void __fastcall b_attack_bombClick(TObject *Sender);
        void __fastcall b_iaClick(TObject *Sender);
        void __fastcall b_exitClick(TObject *Sender);
        void __fastcall b_coordClick(TObject *Sender);
        void __fastcall FormCreate(TObject *Sender);
        void __fastcall add_parClick(TObject *Sender);
        void __fastcall b_startClick(TObject *Sender);
        void __fastcall timerTimer(TObject *Sender);
        void __fastcall b_stopClick(TObject *Sender);
        void __fastcall fieldMouseDown(TObject *Sender,
          TMouseButton Button, TShiftState Shift, int X, int Y);

private:
 TPoint abs_coord[7],obj_size;
 TRect model_coord[5];
 vector <bool> visible,h_show;
 Graphics::TBitmap *Area;
 Graphics::TBitmap *Temp,*Model;
 int f_obj_rad,on_base[3],alive[3];
 double expand_coeff;	// User declarations
public:		// User declarations
//__inline bool is_intercept_onair();
__inline bool is_attack_onair(attack_air);
         void info_out();
        __fastcall TMain_form(TComponent* Owner);
          Graphics::TBitmap *enviroment(double);
};
//--------------------   
__inline bool TMain_form::is_attack_onair(attack_air pl)
//      false
{
if((pl.x==objects[5].x && pl.y==objects[5].y)|| \
(pl.x==objects[6].x && pl.y==objects[6].y))
 return false;
return true;
}
//==============      
 struct is_loaded
{
public:
 bool bomb,
 ia,
 fighter,
 rls,
 zrk,
 add,
 obj,
 was_started;
 void all_false();
  is_loaded();
};

//-------------------------     
class init_strucs_from_file
{
char str[128];
public:
FILE *f;
void Load_objects(target &);
void Load_planes(planes &);
void Load_zrk(ZRK &);
void Load_rls(RLS &);
void Load_adv_atack();
void str_miss();
};
 //---------------------------------------------------------------------------

extern PACKAGE TMain_form *Main_form;

//---------------------------------------------------------------------------
#endif
