#ifndef _RLS_H_
#define _RLS_H_

#include "../Global.h"

struct Otmetka // ,   
{double t;
 double x,y,z;
 double sigx,sigy,sigz;
 int q;
 int nmb;
 bool b;
};

struct FirstDot //  
{double t0;
 double x0,y0,z0;
 double sigx,sigy,sigz;
 int nmb;
 bool b;
};

struct traekt //  
{double t; //  
 double t0;// 
 double x0, y0, z0;//
 double vx0, vy0, vz0;//
 double Psix00,Psix01,Psix10,Psix11; // .    !
 double Psiy00,Psiy01,Psiy10,Psiy11;
 double Psiz00,Psiz01,Psiz10,Psiz11;
 int nmb; //  
 int k; //  
 bool b;
 int length;
 bool zrk;
};

struct mob
    {double x,y,z,t;
     int nmb;
     int k;
     int nzrk;
     int tr;
     bool obs;
    };

typedef vector<mob> Vint;

double RandG (double x1, double x2); // 

class rls //, 
{
 vector<Otmetka> masOtmetok; //
 vector<FirstDot> masFirstDot;
 vector<int> masZapZRK;

//    !!!!!
 double PERIOD; //period of our station in takts...
 double HMin; //min h, where i see
 double HMax; //max h, where i see
 double vmin; //min v of enemy
 double vmax; //max v of enemy
 double LMax; //max length i see
 double LMaxLow; //max length i see on the hmin
 double LMinHigh; //min length i see on the hmax

 double HMinFar; //min h that i see on the LMax
 double EPS; //my error

 double zrk1x; //zr1 x and y
 double zrk1y;
 double zrk1r; //zrk1 radius
 double zrk2x; //srk2
 double zrk2y;
 double zrk2r;
 double objx; //object koords;
 double objy;
 double r_max_our_fire; //max our plane radius
 double optimal_h_to_fly; //optimul h to our plane fly
 int MaxIMPORT; //maximum importance of object;

 int rocket_zrk;
 struct ntonmb
       { int n;
         double x,y,z,r;
         int * imp;
         bool izinbattle;
       };
 vector<ntonmb> masimp;

 //!!!!!

 bool is_seen (double x, double y, double z);//, ,    
 void MTform();//  



 void Sglazh();//4,  ,   
 void KorrOtm();//  
 void ZavTr();// .
 void PTform();//  
 void TRZNACH();
 void TRdel();// 


public:
 vector<traekt> masTraekt;
 rls ();
 void rls_init();
 void one_takt();//       
 void prnPT();
 void prnMO();

 __inline int ret_numb_tr() {return masTraekt.size();};

 void prntraekt();
 void prn_i_traekt(int n);
 bool airport ();//  ,   
 bool boegot();

 void whereflyin(double Myx,double Myy,double Myz,double r,
                int n);

 void whereflyout(masobstrel * m);

 bool wherefly(double Myx,double Myy,double Myh,
              double r,
              double &x,double &y,double &h,
              int &n);//  ,  

 void getkoordzrk(int Numb, double &x, double &y, double &r,double &VmaxR ); //  ,  
 void firein (int n);

 double get_t(double x,  double y,  double z,
             double vx, double vy, double vz,
             double x0, double y0, double z0,
             double Vm);

 void fireout (struct masobstrel1 * m);



/*
bool fire(int Numb,double *x,double *y,double *h,int *n)//,  ...
{ double zrkx,zrky,zrkr;
  int leng;
  double takt;
  int i;
  getkoordzrk(Numb,&zrkx,&zrky,&zrkr);
  leng=masTraekt.size();
  for(i=0;i<leng;i++)
   { if(!masTraekt[i].k) {continue;};
     takt=cur_time-masTraekt[i].t;
     if((zrkx-masTraekt[i].x0)*(zrkx-masTraekt[i].x0)+
     (zrky-masTraekt[i].y0)*(zrky-masTraekt[i].y0)>=
     		(zrkr-vmax*takt)*(zrkr-vmax*takt))  {continue;};
     break;
   };

  if(i==leng) {return FALSE;};
  *x=masTraekt[i].x0+masTraekt[i].vx0*takt;
  *y=masTraekt[i].y0+masTraekt[i].vy0*takt;
  *h=masTraekt[i].z0+masTraekt[i].vz0*takt;
  *n=masTraekt[i].nmb;
  masTraekt[i].k-=rocket_zrk;
  return TRUE;
}

bool gettarget(int Numb,double *x,double *y,double *h)
{ int leng;
  double takt;
  int i;
  leng=masTraekt.size();
  for(i=0;i<leng;i++)
    { if(masTraekt[i].nmb!=Numb) continue;
      break;
    }
  if(i==leng) return FALSE;
  takt=cur_time-masTraekt[i].t;
  *x=masTraekt[i].x0+masTraekt[i].vx0*takt;
  *y=masTraekt[i].y0+masTraekt[i].vy0*takt;
  *h=masTraekt[i].z0+masTraekt[i].vz0*takt;
  return TRUE;
} */

bool is_view (int n);
int where_view (int n);
void killairzrk (int n);// .       ,
void killair (int n);// .       ,

} ;
extern rls rls_var;
#endif // _RLS_H_

