#include	<list>
#include "../rls/rls.h"
//        , 
//    -   -  
//    
//       1     1000/
//       0.28

//    -  
//  / -  
//  -  /

#define	STATE_NOTREADY		0	//  
#define STATE_READINESS1	1	// 1
#define	STATE_ONAIR		2	//    
#define FOUGASSE_KILL_RADIUS	0.1	//   
#define	SPLINTER_KILL_RADIUS	0.3	//   
#define OUR_KILL_PROBABILITY	0.1	//   
#define ENEMY_ATTACK_RADIUS	10	//     

class CFighters
{
public:
	//CFighters();
	AnsiString	Name;// :)     
        int		Number;//   -  
        int		State;	//
        int		Tacts;  //      
        int		nTr;	// ,   
	//   
	double	x;
	double	y;
	double	h;

	//     
	double	xWhere;
	double	yWhere;
	double	hWhere; //  hWhere==0 ->   :)

        int	nRockets;		// -   
        double	fFuel;			// -  
};

class CAirports
{
public:
       // CAirports();

	/*CAirports(double ax, double ay,int Num, double MaxSpeed,double MaxFuel,\
        	double FuelPerTact,int MaxRock, double RockDist, double RockPow,
                int WorkPerid,int ToReadiness1, int ToFly)\

		:fMaxFuel(MaxFuel),fFuelPerTact(FuelPerTact),\
		nMaxRockets(MaxRock), fRocketDistance(RockDist),\
		fRocketPower(RockPow), x(ax),y(ay),fMaxSpeed(MaxSpeed),\
                nWorkPeriod(WorkPerid),nToReadiness1(ToReadiness1),nToFly(ToFly)
	{
        /*        nWorkTacts = 0;
		for(int i=0; i<Num; i++)
		{
			CFighters	fighter;
                        fighter.State = STATE_NOTREADY;
                        fighter.Tacts = 0;
                        fighter.Name.sprintf(" %d",i);
			fighter.x = x;
       			fighter.y = y;
                        fighter.h = 0;
                        fighter.xWhere = x;
                        fighter.yWhere = y;
                        fighter.hWhere = 0;
                        fighter.nRockets = nMaxRockets;
                        fighter.fFuel = fMaxFuel;
                        fighter.nTr = -1;
			fighter.Number = i;
                        listFighters.push_back(fighter);
		}*/
    //	;};

	//  
	double	x;
	double	y;

	std::list<CFighters>	listFighters;

        int	nWorkTacts;	//      
        int	nWorkPeriod;	//      
        int	nToReadiness1;	//      1
        int	nToFly;		//      1

	double	fMaxSpeed;	//   

	double	fMaxFuel;	//  -   
	double	fFuelPerTact;	// -     

	int	nMaxRockets;	//  -    
	double	fRocketDistance;//   
	double	fRocketPower;	//   [0..1] -     

        void	Tact();	//     ,     
	bool	Fire(double x, double y, double h,CFighters f);
        void    Defence_Init(int);
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
};

////////////////////////////////////////////////////////////////////////////////

void  CAirports::Defence_Init(int Num)
{


	x=objects[tt_IA_home].x;
	y=objects[tt_IA_home].y;

	nWorkPeriod=1;
    nToReadiness1=1;
    nToFly=1;

	fMaxSpeed=(double)current_defence_fighter.Vmax/SPEED_COEF;

	fMaxFuel=(double)current_defence_fighter.radius*dt/fMaxSpeed;	//  -   
	fFuelPerTact=dt;

	nMaxRockets=current_defence_fighter.weapon;	//  -    
	fRocketDistance=10;//   
	fRocketPower=current_defence_fighter.pr;	//   [0..1] -     

        nWorkTacts = 0;
		for(int i=0; i<Num; i++)
		{
			CFighters	fighter;
                        fighter.State = STATE_NOTREADY;
                        fighter.Tacts = 0;
                        fighter.Name.sprintf(" %d",i);
			fighter.x = x;
       			fighter.y = y;
                        fighter.h = 0;
                        fighter.xWhere = x;
                        fighter.yWhere = y;
                        fighter.hWhere = 0;
                        fighter.nRockets = nMaxRockets;
                        fighter.fFuel = fMaxFuel;
                        fighter.nTr = -1;
                        fighter.Number = i;
                        listFighters.push_back(fighter);
		}
};


void CAirports::Tact()
{
         //      
	if(nWorkTacts)
        	nWorkTacts--;

        //    ,      whereflyin
        std::list<CFighters>::iterator	ii;
        int inCounter = 0;
	for(ii = listFighters.begin();ii!=listFighters.end();ii++)
        {
                if(ii->h!=0)//     
                {
                        double fDist2Home = sqrt(ii->h*ii->h+(ii->x - x)*(ii->x - x)+(ii->y - y)*(ii->y - y));
                        if(fDist2Home > (ii->fFuel/fFuelPerTact)*fMaxSpeed*0.9 || ii->nRockets==0)
                        {
                        	continue;
                        }

			//      
                        double fPosFuel;
                        fPosFuel = ii->fFuel - ((fFuelPerTact/1.1)*fDist2Home/fMaxSpeed);
                        double fPosRad;
                        fPosRad = (fPosFuel/2)/fFuelPerTact * fMaxSpeed;

        		rls_var.whereflyin(ii->x,ii->y,ii->h,fPosRad,ii->Number);
                        inCounter++;
                }
        }
        //
        struct masobstrel * pMas = new struct masobstrel[inCounter];
        rls_var.whereflyout(pMas);

        ii=listFighters.begin();
        //    
        while(ii!=listFighters.end())
        {
		if(ii->fFuel<0)//   
                {
                	//    :)
                        ii=listFighters.erase(ii);
                        continue;
                }

                ////////////////////////////////////////////////////////////////

        	if(ii->h!=0 && ii->hWhere==0)//    
                {
                	double fDistance = sqrt((ii->h - ii->hWhere)*(ii->h - ii->hWhere)+\
	                        (ii->x - ii->xWhere)*(ii->x - ii->xWhere)+\
                                (ii->y - ii->yWhere)*(ii->y - ii->yWhere));
                        if(fDistance>fMaxSpeed)//       
                        {
                        	double vX = -ii->x + ii->xWhere;
                                double vY = -ii->y + ii->yWhere;
                                double vH = -ii->h + ii->hWhere;
                                vX = vX * fMaxSpeed / fDistance;
                                vY = vY * fMaxSpeed / fDistance;
                                vH = vH * fMaxSpeed / fDistance;
                                ii->x += vX;
                                ii->y += vY;
                                ii->h += vH;
                                ii->fFuel-=fFuelPerTact;
                        }
                        else// 
                        {
                                ii->State = STATE_READINESS1;
                                ii->Tacts = 0;
                                ii->x = x;
                                ii->y = y;
                                ii->h = 0;
                                ii->fFuel = fMaxFuel;
                                ii->nRockets = nMaxRockets;
                                if(nWorkTacts<nWorkPeriod)
                                	nWorkTacts = nWorkPeriod;
                                if( objects[tt_IA_home].life == 0 ) intercept_num--;
                        }
                        ii++;
                	continue;
                }//  

                ////////////////////////////////////////////////////////////////

                if(ii->h==0)//     
                {
                        if(ii->State==STATE_NOTREADY)
                        {
                                if(ii->Tacts!=0)
                                {
                                	if(--(ii->Tacts) == 0)
                                        {//    1
                                               // fuck<<endl<<ii->Name.c_str()<<"    1";
                                                ii->State=STATE_READINESS1;
                                        }
                                        ii++;
                                        continue;
                                }
                                else
                                {
                                	if(1)
                                        {
                                        	ii->Tacts = nToReadiness1;
                                                ii++;
                                                continue;
                                        }
                                }
                        }//STATE_NOTREADY
                        if(ii->State==STATE_READINESS1)
                        {
                        	if(ii->Tacts!=0)
                                {
                                	if(--(ii->Tacts) == 0)
                                        {//    
                                                ii->State=STATE_ONAIR;

                                        }
                                        ii++;
                                        continue;
                                }
                                else
                                {
                                       //	if(fly())
                                        //{
                                        	ii->Tacts = nToFly;
                                                ii++;
                                                continue;
                                        //}
                                }
                        }//STATE_READINESS1
                        if(ii->State==STATE_ONAIR)
                        {
                		if(nWorkTacts!=0)
                        	{
                        		ii++;
                                	continue;//   ""   
	                        }
                        	if(rls_var.airport()==true && objects[tt_IA_home].life ) //    ?
	                        {
	                                //     

	                        	nWorkTacts = nWorkPeriod;
	                                ii->x = x;
	                                ii->y = y;
	                                ii->h += fMaxSpeed;
	                                ii->xWhere = x;
	                                ii->yWhere = y;
	                                ii->hWhere = ii->h;
	                                ii->fFuel -= fFuelPerTact;
                                }
	                        ii++;
	                        continue;
	                }//STATE_ONAIR
                }//   
                ////////////////////////////////////////////////////////////////

               	if(ii->h!=0 && ii->hWhere!=0) //     
                {
                        // ,           
                        double fDist2Home = sqrt(ii->h*ii->h+\
	                        (ii->x - x)*(ii->x - x)+\
                                (ii->y - y)*(ii->y - y));
                        if(fDist2Home > (ii->fFuel/fFuelPerTact)*fMaxSpeed*0.9 || ii->nRockets==0)
                        {
                        	//  
                                ii->xWhere = x;
                                ii->yWhere = y;
                                ii->hWhere = 0;
                                ii->fFuel-=fFuelPerTact;
                                ii++;
                                continue;
                        }

                        double px;
                        double py;
                        double ph;

                        //      
                        //double fPosFuel;
                        //fPosFuel = ii->fFuel - ((fFuelPerTact/1.1)*fDist2Home/fMaxSpeed);
                        //double fPosRad;
                        //fPosRad = (fPosFuel/2)/fFuelPerTact * fMaxSpeed;

                        //bool ret = wherefly(ii->x,ii->y,ii->h,fPosRad, px, py, ph, ii->nTr);

                        //    
                        struct masobstrel* pM;
                        for(int k=0;k<inCounter;k++)
                        {
                        	if(pMas[k].number == ii->Number)
                                {
                                	pM = pMas+k;
                                        break;
                                }
                        }
                        if(pM->flagfly)
                        {//
      //                          if(pM->nmb == -1)// ,   
        //                        {
                                        //ii->hWhere = 0;
//                                        ii++;
  //                                      continue;
    //                            }
                        	ii->hWhere = pM->z;
                                ii->xWhere = pM->x;
                                ii->yWhere = pM->y;

	                	double fDistance = sqrt((ii->h - ii->hWhere)*(ii->h - ii->hWhere)+\
		                        (ii->x - ii->xWhere)*(ii->x - ii->xWhere)+\
                	                (ii->y - ii->yWhere)*(ii->y - ii->yWhere));

	                        if(fDistance>fMaxSpeed)//       
        	                {
                	        	double vX = -ii->x + ii->xWhere;
                        	        double vY = -ii->y + ii->yWhere;
                                	double vH = -ii->h + ii->hWhere;
	                                vX = vX * fMaxSpeed / fDistance;
        	                        vY = vY * fMaxSpeed / fDistance;
                	                vH = vH * fMaxSpeed / fDistance;
	                                ii->x += vX;
        	                        ii->y += vY;
                	                ii->h += vH;
                        	        ii->fFuel-=fFuelPerTact;
	                        }
	                        else //    
	                        {
	                                ii->x = ii->xWhere;
        	                        ii->y = ii->yWhere;
                	                ii->h = ii->hWhere;
	                                ii->fFuel-=fFuelPerTact;
                                }
                                ii++;
                                continue;
                        }
                        else
                        {//
                                bool IAmKilled = Fire(pM->x,pM->y,pM->z,*ii);
                                if(IAmKilled)
                                {
                                        rls_var.killair(ii->nTr);
                                	ii = listFighters.erase(ii);
                                        intercept_num--;
                                        continue;
                                }
                                else ii->nRockets--;
                                ii++;
                                continue;
                        }
                }//    
        }
	delete pMas;
}


///////////////////////////////////////////////////////////////////////////////
// ,  ,    
//     
///////////////////////////////////////////////////////////////////////////////
bool CAirports::Fire(double x,double y,double h, CFighters f)
{
	std::vector<attack_air>::iterator	ii,jj;
        jj = attack_vector_air.end();
        double d=ENEMY_ATTACK_RADIUS;
        //   
	for(ii=attack_vector_air.begin();ii!=attack_vector_air.end();ii++)
        {//    
        	double t = sqrt((ii->x-f.x)*(ii->x-f.x)+(ii->y-f.y)*(ii->y-f.y)+(ii->h-f.h)*(ii->h-f.h));
                if(t<d && ii->rocket)
                {
                	jj=ii;
                        d=t;
                }
        }

        bool ret = false;
        if(jj==attack_vector_air.end())
        {
        	ret = false;
        }
        else
        {
        	jj->rocket--;
                if((double)rand()/RAND_MAX < OUR_KILL_PROBABILITY)
               	        ret = true;
        }

        if( ret ) return ret;

        //  
        for(ii=attack_vector_air.begin();ii!=attack_vector_air.end();ii++)
        {
                if(ii->life==0)
                	continue;
        	double fDist = sqrt((ii->x-x)*(ii->x-x)+(ii->y-y)*(ii->y-y)+(ii->h-h)*(ii->h-h));
		if(fDist<FOUGASSE_KILL_RADIUS)
                {//  
                        	ii->life--;
                };
                if(fDist<SPLINTER_KILL_RADIUS)
                {//    
                	if((double)rand()/RAND_MAX < fRocketPower)
                        	ii->life--;
                };
        }

        return ret;
}

