#include "rls.h"

struct pltr
 {double vx,vy,vz,x,y,z;
  double time;
 };

vector <pltr> svtr;

void GenerateTraeks (int);
void GenerateTraeks1 (int, double, double, double);
void GenerateTraeks2 (int, double, double, double, int);
void ConfirmTraeks ();
void newtraek();
void deltraek(int);
//void testTraekt();
//void INIT ();
void maintest(rls&);

void prn_i_air(int);
void new_rand (int);
void new_bombE (double,double,double,int);
void new_fighterE (double,double,double,int);
int ret_numb_air() {return svtr.size();};
void getzrk(int,double,double,double);
void getair(int,double,double,double);


/*void INIT ()
 {current_defence_fighter.Vmin=1400; //su27
  current_defence_fighter.Vmax=2750;
  current_defence_fighter.Vcruise=2000;
  current_defence_fighter.Hmin=100;
  current_defence_fighter.Hmax=27000;
  current_defence_fighter.Hoptimal=17000;
  current_defence_fighter.radius=50000;

  current_attack_bomb.Vmin=500;//f117
  current_attack_bomb.Vmax=1040;
  current_attack_bomb.Vcruise=800;
  current_attack_bomb.Hmin=1000;
  current_attack_bomb.Hmax=25000;
  current_attack_bomb.Hoptimal=17000;


  current_rls.radius=800000;
  current_rls.Hmin=30;
  current_rls.Hmax=30000;
  current_rls.Lmax=current_rls.radius;
  current_rls.Lminhigh=3000;
  current_rls.Hminfar=3000;
  current_rls.Lmaxlow=500;
  current_rls.Eps=2;
  current_rls.period=1;

  current_zrk_mon.Lmax=170000;
  current_zrk_mon.Lmin=100;
  current_zrk_mon.Hmin=30;
  current_zrk_mon.Hmax=30000;
  current_zrk_mon.Vmax=5000;

  current_zrk_mult.Lmax=150000;         //s300
  current_zrk_mult.Lmin=20;
  current_zrk_mult.Hmin=10;
  current_zrk_mult.Hmax=27000;
  current_zrk_mult.Vmax=5000;


  objects[tt_RLS].x=0;   //koords
  objects[tt_RLS].y=0;
  objects[tt_RLS].life=20;
  objects[tt_RLS].target_type=tt_RLS;
  objects[tt_RLS].importance=5;

  objects[tt_ZRK_mon].x=-150000;
  objects[tt_ZRK_mon].y=-30000;
  objects[tt_ZRK_mon].importance=1;


  objects[tt_ZRK_mult].x=-155000;
  objects[tt_ZRK_mult].y=130000;
  objects[tt_ZRK_mult].importance=1;

  objects[tt_OBJ].x = 30000;
  objects[tt_OBJ].y = -10000;
  objects[tt_OBJ].importance=6;


  objects[tt_IA_home].x = 150000;
  objects[tt_IA_home].y = 150000;
  objects[tt_IA_home].importance=3;

  svtr.reserve(200);
  attack_vector_air.reserve(200);
  attack_vector_group.reserve(200);
  svtr.resize(0);
  attack_vector_air.resize(0);

 };
  */

void prn_i_air(int n)
{if (n>=attack_vector_air.size()) {printf ("no such number!!\n"); return;};
 printf ("%d airplane is in (%f, %f, %f) with (%f, %f, %f) speed.\n",n,
         attack_vector_air[n].x, attack_vector_air[n].y, attack_vector_air[n].h,
         svtr[n].vx,svtr[n].vy,svtr[n].vz);
 if (attack_vector_air[n].type==1) printf ("It's bomber\n");
                            else   printf ("It's fighter\n");
};


void new_rand (int n)
{int Vsred=((int)current_attack_bomb.Vmax+(int)current_attack_bomb.Vmin)>>1;
 int Hsred=((int)current_attack_bomb.Hmax+(int)current_attack_bomb.Hmin)>>1;
 int i=svtr.size();
  svtr.resize(i+n);
  attack_vector_air.resize(i+n);
while (i<svtr.size()) {
  svtr[i].vz=0;
  svtr[i].vx=Vsred+(int)(-100.0+(double)rand()*(double)200.0
                                              /(double)RAND_MAX);
  svtr[i].vy=(int)(-100.0+(double)rand()*(double)200.0
                                              /(double)RAND_MAX);
  if ((svtr[i].vy*svtr[i].vy+svtr[i].vx*svtr[i].vx)>
     current_attack_bomb.Vmax*current_attack_bomb.Vmax)
         svtr[i].vy=0;
  svtr[i].x=-current_rls.radius+(-100.0+(double)rand()*(double)200.0
                                              /(double)RAND_MAX);
  svtr[i].y=(-100.0+(double)rand()*(double)200.0
                                              /(double)RAND_MAX);
  svtr[i].z=Hsred+(-2.0+(double)rand()*(double)4.0/(double)RAND_MAX);
  svtr[i].time=cur_time;
  attack_vector_air[i].life=2;
  attack_vector_air[i].x=svtr[i].x;
  attack_vector_air[i].y=svtr[i].y;
  attack_vector_air[i].h=svtr[i].z;
  attack_vector_air[i].type=rand()&1;
  i++;
  };
};

void new_fighterE (double x1, double y1, double z1, int obj)
{int i=svtr.size();
 int Vsred=((int)current_attack_bomb.Vmax+(int)current_attack_bomb.Vmin)>>1;
 int Hsred=((int)current_attack_bomb.Hmax+(int)current_attack_bomb.Hmin)>>1;

 double vv;
 svtr.resize(i+1);
 attack_vector_air.resize(i+1);
 svtr[i].x=x1;
 svtr[i].y=y1;
 svtr[i].z=z1;
 svtr[i].vz=0;
 vv=sqrt((objects[obj].x-svtr[i].x)*(objects[obj].x-svtr[i].x)+
                               (objects[obj].y-svtr[i].y)*(objects[obj].y-svtr[i].y));
 vv/=Vsred;
 svtr[i].vx=(objects[obj].x-svtr[i].x)/vv;
 svtr[i].vy=(objects[obj].y-svtr[i].y)/vv;
 if ((svtr[i].vy*svtr[i].vy+svtr[i].vx*svtr[i].vx)>
      current_attack_bomb.Vmax*current_attack_bomb.Vmax)
                             svtr[i].vy=0;
 svtr[i].time=cur_time;
 attack_vector_air[i].life=2;
 attack_vector_air[i].x=svtr[i].x;
 attack_vector_air[i].y=svtr[i].y;
 attack_vector_air[i].h=svtr[i].z;
 attack_vector_air[i].type=0;
};


void new_bombE (double x1, double y1, double z1, int obj)
{int i=svtr.size();
 int Vsred=((int)current_attack_bomb.Vmax+(int)current_attack_bomb.Vmin)>>1;
 int Hsred=((int)current_attack_bomb.Hmax+(int)current_attack_bomb.Hmin)>>1;

 double vv;
 svtr.resize(i+1);
 attack_vector_air.resize(i+1);
 svtr[i].x=x1;
 svtr[i].y=y1;
 svtr[i].z=z1;
 svtr[i].vz=0;

 vv=sqrt((objects[obj].x-svtr[i].x)*(objects[obj].x-svtr[i].x)+
                               (objects[obj].y-svtr[i].y)*(objects[obj].y-svtr[i].y));
 vv/=Vsred;
 svtr[i].vx=(objects[obj].x-svtr[i].x)/vv;
 svtr[i].vy=(objects[obj].y-svtr[i].y)/vv;
 if ((svtr[i].vy*svtr[i].vy+svtr[i].vx*svtr[i].vx)>
      current_attack_bomb.Vmax*current_attack_bomb.Vmax)
                             svtr[i].vy=0;
 svtr[i].time=cur_time;
 attack_vector_air[i].life=2;
 attack_vector_air[i].x=svtr[i].x;
 attack_vector_air[i].y=svtr[i].y;
 attack_vector_air[i].h=svtr[i].z;
 attack_vector_air[i].type=1;
};


void maintest(rls &myRLS)
{ int i=0;
 int j,n;
 int d;
 double x,y,z,RR;
 int key;

GenerateTraeks(20);
 printf ("Input, what do you want: [1]-test traekt; [2]-test get target for ZRK; [3]-get target for fighter; [4]-get raspredelenie: ");
 scanf("%d",&key);

 switch (key){
 case 1:
      printf ("Do you want to see one traekt? [1]-Yes, [2]-No:");
      scanf ("%d",&key);
      switch (key) {
       case 1:
       attack_vector_air.resize(1);
       svtr.resize(1);

       svtr[0].x=-800000;
       svtr[0].y=1000;
       svtr[0].z=2800;
       svtr[0].vx=800;
       svtr[0].vy=-10;
       svtr[0].vz=0;
       svtr[0].time=cur_time;

       attack_vector_group[0].n_bomb=0;
       attack_vector_air[0].life=2;
       attack_vector_air[0].x=svtr[0].x;
       attack_vector_air[0].y=svtr[0].y;
       attack_vector_air[0].h=svtr[0].z;

       printf("U = (%f,%f,%f)\n",svtr[0].vx, svtr[0].vy, svtr[0].vz);
       getch;
       i=0;
 		while (i<100)
   		{cur_time+=1;
    		 ConfirmTraeks();
    		 myRLS.one_takt();
          myRLS.prntraekt();
          printf("Real coords = (%f,%f,%f)\n",svtr[0].x, svtr[0].y, svtr[0].z);
          printf ("%d iteration!\n",i);
          getch();
          i++;
   		};
       break;
       case 2:
      printf ("There were generate next traeks:\n");
      for(j=0; j<svtr.size(); j++)
       {printf ("%d traekt in (%f,%f,%f), with U = (%f,%f,%f)\n",
                j,svtr[j].x,svtr[j].y,svtr[j].z,svtr[j].vx,svtr[j].vy,svtr[j].vz);};
      getch();
 		myRLS.one_takt();
 		printf ("first iteration!\n");
      getch();
		myRLS.prntraekt();

 		while (i<20)
   		{cur_time+=1;
    		 ConfirmTraeks();
    		 myRLS.one_takt();
          myRLS.prntraekt();
          printf ("next iteration!\n");
          getch();
          i++;
   		};
		newtraek();
		newtraek();
		i=0;
		while (i<20)
   		{cur_time+=1;
    		 ConfirmTraeks();
          myRLS.one_takt();
          myRLS.prntraekt();
          printf ("next iteration!\n");
          getch();
    		 i++;
		};
        break;
      default: break;
      };

 break;
 case 2:
 //for ZRK
 GenerateTraeks1(20,-150000,0,10000);
 myRLS.one_takt();
 i=0;
 while (i<20)
  {cur_time+=1;
   ConfirmTraeks();
   myRLS.one_takt();
   i++;
  };
 printf ("Now i ask from zrk1 for target:\n ");
// if (myRLS.fire(2,&x,&y,&z,&n)) {printf ("fire 2-nd ZRK on (%f, %f, %f), %d target\n", x,y,z,n);}
  //					else {printf ("I'll wait");};
// if (myRLS.fire(2,&x,&y,&z,&n)) {printf ("fire on (%f, %f, %f), %d target\n", x,y,z,n);}
  //					else {printf ("I'll wait");};
 printf ("Real coords 0 traekt: (%f, %f, %f)\n",attack_vector_air[0].x,
 																attack_vector_air[0].y,
                                                attack_vector_air[0].h);
// if (myRLS.fire(1,&x,&y,&z,&n)) {printf ("fire 1-st ZRK on (%f, %f, %f), %d target\n", x,y,z,n);}
  //					else {printf ("I'll wait");};
 printf ("Real coords 3 traekt: (%f, %f, %f)\n",attack_vector_air[2].x,
 																attack_vector_air[2].y,
                                                attack_vector_air[2].h);
 printf ("Press any key\n");
 getch();
 printf ("Now we'll confirm traektory:\n");
 i=0;
 while (i<20)
  {cur_time+=1;
   ConfirmTraeks();
   myRLS.one_takt();
   printf ("This is RLS koords, 3 traekt.\n ");
   printf (" (%f,%f,%f)\n",svtr[2].x,svtr[2].y,svtr[2].z);
   printf ("And there is sent koords of 3 traekt:\n ");
//   myRLS.gettarget(n,&x,&y,&z);
   printf (" (%f,%f,%f)\n",x,y,z);
   getch();
   i++;
  };
 break;
 case 3:
 //ISTREB
 GenerateTraeks1(20,-150000,0,10000);
 myRLS.one_takt();
 i=0;
 while (i<20)
  {cur_time+=1;
   ConfirmTraeks();
   myRLS.one_takt();
   i++;
  };

  printf ("We'll see a target: \n");
  if (myRLS.wherefly(-140000,100,11000, 120000,x,y,z,n))
                    {printf ("I shall fly to (%f,%f,%f)\n",x,y,z);}
                    else
							{printf ("I shall fire to (%f,%f,%f)\n and that is a %d plane\n",
                               x,y,z,n);
                      printf ("Real koords of n target is : (%f,%f,%f)\n",
                                                attack_vector_air[n].x,
 																attack_vector_air[n].y,
                                                attack_vector_air[n].h);
                     };
  printf ("plane that is  very far from enemy\n");
  if (myRLS.wherefly(300000,500000,11000, 1000000,x,y,z,n))
                    {printf ("I shall fly to (%f,%f,%f)\n",x,y,z);}
                    else
							{printf ("I shall fire to (%f,%f,%f)\n and that is a %d plane\n",
                               x,y,z,n);
                      printf ("Real koords of n target is : (%f,%f,%f)\n",
                                                attack_vector_air[n].x,
 																attack_vector_air[n].y,
                                                attack_vector_air[n].h);
                     };
 getch();
 break;
 case 4:
 //raspredelenie
 svtr.resize(0);
 attack_vector_air.resize(0);
 printf ("Input number of objects: ");
 scanf ("%d",&i);
 GenerateTraeks2(2,-800000,0,10000,i);
 printf ("Input number of objects: ");
 scanf ("%d",&i);
 GenerateTraeks2(2,-800000,0,10000,i);
 printf ("Input number of objects: ");
 scanf ("%d",&i);
 GenerateTraeks2(2,-800000,0,10000,i);
 printf ("Input number of objects: ");
 scanf ("%d",&i);
 GenerateTraeks2(2,-800000,0,10000,i);
 printf ("Input number of objects: ");
 scanf ("%d",&i);
 GenerateTraeks2(2,-800000,0,10000,i);
 for (i=0; i<svtr.size(); i++) printf ("traeks: %f %f %f %f %f %f\n",
                                        svtr[i].x,svtr[i].y,svtr[i].z,
                                        svtr[i].vx,svtr[i].vy,svtr[i].vz);

 getch();
 myRLS.one_takt();

 i=0;
 while (i<20)
  {cur_time+=1;
   ConfirmTraeks();
   myRLS.one_takt();
   myRLS.prntraekt();
   getch();
   i++;
  };
 getch();
 break;

 default: break;
 };

};



void GenerateTraeks2 (int n, double x1, double y1, double z1, int obj)
 {int i=svtr.size();
  int Vsred=((int)current_attack_bomb.Vmax+(int)current_attack_bomb.Vmin)>>1;
  int Hsred=((int)current_attack_bomb.Hmax+(int)current_attack_bomb.Hmin)>>1;
  double vv;
  svtr.resize(i+n);
  attack_vector_air.resize(i+n);
  attack_vector_group.resize(i+n);

  while (i<svtr.size()) {svtr[i].x=x1+(-100.0+(double)rand()*(double)700.0
                                              /(double)RAND_MAX);
                       svtr[i].y=y1+(-100.0+(double)rand()*(double)700.0
                                              /(double)RAND_MAX);
                       svtr[i].z=z1+(-2.0+(double)rand()*(double)100.0
                                                    /(double)RAND_MAX);
                       svtr[i].vz=0;

                       vv=sqrt((objects[obj].x-svtr[i].x)*(objects[obj].x-svtr[i].x)+
                               (objects[obj].y-svtr[i].y)*(objects[obj].y-svtr[i].y));
                       vv/=Vsred;
  							  svtr[i].vx=(objects[obj].x-svtr[i].x)/vv;
                       svtr[i].vy=(objects[obj].y-svtr[i].y)/vv;
                       if ((svtr[i].vy*svtr[i].vy+svtr[i].vx*svtr[i].vx)>
                             current_attack_bomb.Vmax*current_attack_bomb.Vmax)
                             svtr[i].vy=0;
                       svtr[i].time=cur_time;
   						  //attack_vector_group[i].n_bomb=i;
                       attack_vector_air[i].life=2;
                       attack_vector_air[i].x=svtr[i].x;
                       attack_vector_air[i].y=svtr[i].y;
                       attack_vector_air[i].h=svtr[i].z;
                       attack_vector_air[i].type=0;
                       i++;
                       };
 };


void GenerateTraeks1 (int n, double x1, double y1, double z1)
 {int i;
  int Vsred=((int)current_attack_bomb.Vmax+(int)current_attack_bomb.Vmin)>>1;
  int Hsred=((int)current_attack_bomb.Hmax+(int)current_attack_bomb.Hmin)>>1;
  svtr.reserve(200);
  attack_vector_air.reserve(200);
  attack_vector_group.reserve(200);
  svtr.resize(n);
  attack_vector_air.resize(n);
  attack_vector_group.resize(n);

  for (i=0; i<n; i++) {svtr[i].vz=0;
  							  svtr[i].vx=Vsred+(-100.0+(double)rand()*(double)200.0
                                              /(double)RAND_MAX);
                       svtr[i].vy=(-100.0+(double)rand()*(double)200.0
                                              /(double)RAND_MAX);
                       if ((svtr[i].vy*svtr[i].vy+svtr[i].vx*svtr[i].vx)>
                             current_attack_bomb.Vmax*current_attack_bomb.Vmax)
                             svtr[i].vy=0;
                       svtr[i].x=x1+(-100.0+(double)rand()*(double)200.0
                                              /(double)RAND_MAX);
                       svtr[i].y=y1+(-100.0+(double)rand()*(double)200.0
                                              /(double)RAND_MAX);
                       svtr[i].z=z1+(-2.0+(double)rand()*(double)4.0
                                                    /(double)RAND_MAX);
                       svtr[i].time=cur_time;
   						  //attack_vector_group[i].n_bomb=i;
                       attack_vector_air[i].life=2;
                       attack_vector_air[i].x=svtr[i].x;
                       attack_vector_air[i].y=svtr[i].y;
                       attack_vector_air[i].h=svtr[i].z;
                       attack_vector_air[i].type=1;
                       };
 };


void GenerateTraeks (int n)
 {int i;
  int Vsred=((int)current_attack_bomb.Vmax+(int)current_attack_bomb.Vmin)>>1;
  int Hsred=((int)current_attack_bomb.Hmax+(int)current_attack_bomb.Hmin)>>1;
  svtr.reserve(200);
  attack_vector_air.reserve(200);
  attack_vector_group.reserve(200);
  svtr.resize(n);
  attack_vector_air.resize(n);
  attack_vector_group.resize(n);

  for (i=0; i<n; i++) {svtr[i].vz=0;
  							  svtr[i].vx=Vsred+(-100.0+(double)rand()*(double)200.0
                                              /(double)RAND_MAX);
                       svtr[i].vy=(-100.0+(double)rand()*(double)200.0
                                              /(double)RAND_MAX);
                       if ((svtr[i].vy*svtr[i].vy+svtr[i].vx*svtr[i].vx)>
                             current_attack_bomb.Vmax*current_attack_bomb.Vmax)
                             svtr[i].vy=0;
                       svtr[i].x=-current_rls.radius+100+(-100.0+(double)rand()*(double)200.0
                                              /(double)RAND_MAX);
                       svtr[i].y=(-100.0+(double)rand()*(double)200.0
                                              /(double)RAND_MAX);
                       svtr[i].z=Hsred+(-2.0+(double)rand()*(double)4.0
                                                    /(double)RAND_MAX);
                       svtr[i].time=cur_time;
   						  //attack_vector_group[i].n_bomb=i;
                       attack_vector_air[i].life=2;
                       attack_vector_air[i].x=svtr[i].x;
                       attack_vector_air[i].y=svtr[i].y;
                       attack_vector_air[i].h=svtr[i].z;
                       attack_vector_air[i].type=1;
                       //attack_vector_air[i].type=(int)(2*rand()/((double)RAND_MAX+1));
                       };
 };


void ConfirmTraeks ()
 {int i;
  for (i=0; i<svtr.size(); i++) {svtr[i].x+=svtr[i].vx*(cur_time-svtr[i].time);
                                 svtr[i].y+=svtr[i].vy*(cur_time-svtr[i].time);
                                 svtr[i].z+=svtr[i].vz*(cur_time-svtr[i].time);
                                 svtr[i].time=cur_time;
                                 attack_vector_air[i].x=svtr[i].x;
                                 attack_vector_air[i].y=svtr[i].y;
                                 attack_vector_air[i].h=svtr[i].z;
                                 };
 };


void newtraek()
 {int i=svtr.size();
  svtr.resize(i+1);
  attack_vector_air.resize(i+1);
  attack_vector_group.resize(i+1);
  svtr[i].vz=0;
  int Vsred=((int)current_attack_bomb.Vmax+(int)current_attack_bomb.Vmin)>>1;
  int Hsred=((int)current_attack_bomb.Hmax+(int)current_attack_bomb.Hmin)>>1;
  svtr[i].vx=Vsred+(int)(-100.0+(double)rand()*(double)200.0
                                              /(double)RAND_MAX);
  svtr[i].vy=(int)(-100.0+(double)rand()*(double)200.0
                                              /(double)RAND_MAX);
  if ((svtr[i].vy*svtr[i].vy+svtr[i].vx*svtr[i].vx)>
     current_attack_bomb.Vmax*current_attack_bomb.Vmax)
         svtr[i].vy=0;
  svtr[i].x=-current_rls.radius+(-100.0+(double)rand()*(double)200.0
                                              /(double)RAND_MAX);
  svtr[i].y=(-100.0+(double)rand()*(double)200.0
                                              /(double)RAND_MAX);
  svtr[i].z=Hsred+(-2.0+(double)rand()*(double)4.0
                                                    /(double)RAND_MAX);
  svtr[i].time=cur_time;
  attack_vector_air[i].life=2;
  attack_vector_air[i].x=svtr[i].x;
  attack_vector_air[i].y=svtr[i].y;
  attack_vector_air[i].h=svtr[i].z;
  attack_vector_air[i].type=0;
 };



void deltraek(int n)
 {if (n<svtr.size()) {svtr.erase(svtr.begin()+n);
                      attack_vector_air.erase(attack_vector_air.begin()+n);
                     };
 };

void testTraekt()
 {int i=0;
  int j=0;

 GenerateTraeks(20);
 for (i=0; i<attack_vector_group.size(); i++)
 		{printf("%d tr: %d bomder coords: %f, %f, %f\n",i,
      				    attack_vector_group[i].n_bomb,
                      attack_vector_air[attack_vector_group[i].n_bomb].x,
                      attack_vector_air[attack_vector_group[i].n_bomb].y,
                      attack_vector_air[attack_vector_group[i].n_bomb].h);
       getch();
      };
 printf("Input a number: ");
 scanf("%d",&j);
 for (i=0; i<20; i++) {cur_time+=1;
                       newtraek();
                       deltraek(10);
                       ConfirmTraeks ();
							  printf("%d tr: %d bomder coords: %f, %f, %f\n",i,
      				     attack_vector_group[j].n_bomb,
                       attack_vector_air[attack_vector_group[j].n_bomb].x,
                       attack_vector_air[attack_vector_group[j].n_bomb].y,
                       attack_vector_air[attack_vector_group[j].n_bomb].h);
       					  getch();
                       };

};

// new !!!

double RandG (double x1, double x2) // 
{double r=(double)rand()/((double)RAND_MAX+1);
 r=(x1+(x2-x1)*r);
 return r;
};

 bool rls::is_seen (double x, double y, double z)//, ,    
 {
        long double xxx = x*x+y*y;
        long double r=sqrtl(xxx);//   
          return ((z>=HMin)&&(z<=HMax)&&(r<=LMax)&&
	     (((r-LMaxLow)*(HMinFar-HMin)/(LMax-LMaxLow)+HMin)<=z)&&
		 (r*HMax/LMinHigh>=z));// 
 };
void rls::MTform()//  
 {masOtmetok.resize(0);//,  
  int j=0;
  int i=0;
  double x,y,z;
  double S;
  double r;
  while (i<attack_vector_air.size())// 
	{
    if (attack_vector_air[i].life!=0)//  ,
	{x=attack_vector_air[i].x;
    y=attack_vector_air[i].y;
    z=attack_vector_air[i].h;//,  
	 if (is_seen(x,y,z)) {// , 
       r=sqrt(x*x+y*y);
	    S=sqrt(EPS)*(9.*r/LMax+1)/10.; // 
       masOtmetok.resize(j+1);
       masOtmetok[j].x=x+RandG(0,+S);// , 
       masOtmetok[j].y=y+RandG(0,+S);
       masOtmetok[j].z=z+RandG(0,+S/6.);
       masOtmetok[j].sigx=S*S;//
       masOtmetok[j].sigy=S*S;
       masOtmetok[j].sigz=S*S/36.;
       masOtmetok[j].q=0;//  
       masOtmetok[j].nmb=i;//  
       masOtmetok[j].t=cur_time;//  
       if (attack_vector_air[i].type!=0) {masOtmetok[j].b=true;}
                                 else {masOtmetok[j].b=false;};
       j++;
                        };
   };
   i++;
   };
 };


void rls::Sglazh()//4,  ,   
{
int k,i,j;// 
double tij;
double x,y,z;
double dx,dy,dz,Sx,Sy,Sz,f,lambda,w,t;
int J=masOtmetok.size();//  
int I=masTraekt.size();

for(i=0;i<I;i++)//    
{
  k=I;
  lambda=-5;
  for(j=0;j<J;j++)//      
  {
    tij=masOtmetok[j].t-masTraekt[i].t;//  
    x=masTraekt[i].x0+masTraekt[i].vx0*tij;// 
    y=masTraekt[i].y0+masTraekt[i].vy0*tij;
    z=masTraekt[i].z0+masTraekt[i].vz0*tij;

    Sx=masTraekt[i].Psix00+tij*(masTraekt[i].Psix01+masTraekt[i].Psix10)+
						  tij*tij*masTraekt[i].Psix11;// 
    Sy=masTraekt[i].Psiy00+tij*(masTraekt[i].Psiy01+masTraekt[i].Psiy10)+
						  tij*tij*masTraekt[i].Psiy11;
    Sz=masTraekt[i].Psiz00+tij*(masTraekt[i].Psiz01+masTraekt[i].Psiz10)+
 					  	  tij*tij*masTraekt[i].Psiz11;

    dx=masOtmetok[j].x-x;//   
    dy=masOtmetok[j].y-y;
    dz=masOtmetok[j].z-z;

    if((fabs(dx)>3*(sqrt(masOtmetok[j].sigx)+sqrt(Sx)))||
       (fabs(dy)>3*(sqrt(masOtmetok[j].sigy)+sqrt(Sy)))||
       (fabs(dz)>3*(sqrt(masOtmetok[j].sigz)+sqrt(Sz))))
      continue;//  

      f=((dx*dx)/masOtmetok[j].sigx)+((dy*dy)/masOtmetok[j].sigy)+
                                        ((dz*dz)/masOtmetok[j].sigz);
      if((f<lambda)||(lambda<-2))
      {//  
        lambda=f;
        k=j;
      }
  }
  if(k!=I)
  {//  
    masOtmetok[k].q=1;// 
    t=masOtmetok[k].t-masTraekt[i].t;// tau

    x=masTraekt[i].x0+t*masTraekt[i].vx0;// . .
    y=masTraekt[i].y0+t*masTraekt[i].vy0;
    z=masTraekt[i].z0+t*masTraekt[i].vz0;

    dx=masOtmetok[k].x-x;//
    dy=masOtmetok[k].y-y;
    dz=masOtmetok[k].z-z;

    masTraekt[i].Psix00=masTraekt[i].Psix00+2*t*masTraekt[i].Psix01+
                        t*t*masTraekt[i].Psix11;
    masTraekt[i].Psix01=masTraekt[i].Psix01+t*masTraekt[i].Psix11;
    masTraekt[i].Psix10=masTraekt[i].Psix10+t*masTraekt[i].Psix11;

    masTraekt[i].Psiy00=masTraekt[i].Psiy00+2*t*masTraekt[i].Psiy01+
           				   t*t*masTraekt[i].Psiy11;
    masTraekt[i].Psiy01=masTraekt[i].Psiy01+t*masTraekt[i].Psiy11;
    masTraekt[i].Psiy10=masTraekt[i].Psiy10+t*masTraekt[i].Psiy11;

    masTraekt[i].Psiz00=masTraekt[i].Psiz00+2*t*masTraekt[i].Psiz01+
      						 t*t*masTraekt[i].Psiz11;
    masTraekt[i].Psiz01=masTraekt[i].Psiz01+t*masTraekt[i].Psiz11;
    masTraekt[i].Psiz10=masTraekt[i].Psiz10+t*masTraekt[i].Psiz11;

//   
    w=1./masOtmetok[k].sigx;
    f=1+w*masTraekt[i].Psix00;
    masTraekt[i].Psix11=masTraekt[i].Psix11-w*masTraekt[i].Psix01*
    							masTraekt[i].Psix10/f;
    masTraekt[i].Psix00=masTraekt[i].Psix00/f;
    masTraekt[i].Psix01=masTraekt[i].Psix01/f;
    masTraekt[i].Psix10=masTraekt[i].Psix10/f;
    masTraekt[i].x0=x+w*masTraekt[i].Psix00*dx;
    masTraekt[i].vx0=masTraekt[i].vx0+w*masTraekt[i].Psix10*dx;

//  
    w=1./masOtmetok[k].sigy;
    f=1+w*masTraekt[i].Psiy00;
    masTraekt[i].Psiy11=masTraekt[i].Psiy11-w*masTraekt[i].Psiy01*
    							masTraekt[i].Psiy10/f;
    masTraekt[i].Psiy00=masTraekt[i].Psiy00/f;
    masTraekt[i].Psiy01=masTraekt[i].Psiy01/f;
    masTraekt[i].Psiy10=masTraekt[i].Psiy10/f;
    masTraekt[i].y0=y+w*masTraekt[i].Psiy00*dy;
    masTraekt[i].vy0=masTraekt[i].vy0+w*masTraekt[i].Psiy10*dy;

//  
    w=1./masOtmetok[k].sigz;
    f=1+w*masTraekt[i].Psiz00;
    masTraekt[i].Psiz11=masTraekt[i].Psiz11-w*masTraekt[i].Psiz01*
    							masTraekt[i].Psiz10/f;
    masTraekt[i].Psiz00=masTraekt[i].Psiz00/f;
    masTraekt[i].Psiz01=masTraekt[i].Psiz01/f;
    masTraekt[i].Psiz10=masTraekt[i].Psiz10/f;
    masTraekt[i].z0=z+w*masTraekt[i].Psiz00*dz;
    masTraekt[i].vz0=masTraekt[i].vz0+w*masTraekt[i].Psiz10*dz;
//  
    masTraekt[i].t=masOtmetok[k].t;
//   .
    masTraekt[i].nmb=masOtmetok[k].nmb;
    masTraekt[i].b=masOtmetok[k].b;
    masTraekt[i].length++;
  }
 }
}

void rls::KorrOtm()//  
{int i=0;
 while (i<masOtmetok.size())
  {if(masOtmetok[i].q) masOtmetok.erase(masOtmetok.begin()+i); else i++;
  }
};

void rls::ZavTr()// .
{int i,j,h;
 int I,J,H;
 double t;
 double deltaX,deltaY,deltaZ,deltaR;

 H=masFirstDot.size();
 I=masTraekt.size();
 J=masOtmetok.size();//  - .
 if ((J==0)||(H==0)) return;

 i=I;
for (h=0; h<H; h++)
 {for (j=0; j<J; j++){
  t=masOtmetok[j].t-masFirstDot[h].t0;//  , 
  deltaX=masOtmetok[j].x-masFirstDot[h].x0;
  deltaY=masOtmetok[j].y-masFirstDot[h].y0;
  deltaZ=masOtmetok[j].z-masFirstDot[h].z0;
  deltaR=sqrt(deltaX*deltaX+deltaY*deltaY+deltaZ*deltaZ);
  if ((t*vmin>deltaR)||(t*vmax<deltaR) ) continue;//  
 masTraekt.resize(i+1);// 

 masOtmetok[j].q=1;//  
 masTraekt[i].t=masOtmetok[j].t;//     

 masTraekt[i].x0=masOtmetok[j].x;//  
 masTraekt[i].y0=masOtmetok[j].y;
 masTraekt[i].z0=masOtmetok[j].z;

 masTraekt[i].vx0=deltaX/t;// 
 masTraekt[i].vy0=deltaY/t;
 masTraekt[i].vz0=deltaZ/t;

 masTraekt[i].Psix00=masOtmetok[j].sigx;//  
 masTraekt[i].Psix01=masTraekt[i].Psix10=masOtmetok[j].sigx/t;
 masTraekt[i].Psix11=(masOtmetok[j].sigx+masFirstDot[h].sigx)/(t*t);

 masTraekt[i].Psiy00=masOtmetok[j].sigy;
 masTraekt[i].Psiy01=masTraekt[i].Psiy10=masOtmetok[j].sigy/t;
 masTraekt[i].Psiy11=(masOtmetok[j].sigy+masFirstDot[h].sigy)/(t*t);
 masTraekt[i].Psiz00=masOtmetok[j].sigz;
 masTraekt[i].Psiz01=masTraekt[i].Psiz10=masOtmetok[j].sigz/t;
 masTraekt[i].Psiz11=(masOtmetok[j].sigz+masFirstDot[h].sigz)/(t*t);

 masTraekt[i].nmb=masOtmetok[j].nmb; //  
                                         //,   
 masTraekt[i].b=masOtmetok[j].b;
 masTraekt[i].k=0;//     
 masTraekt[i].length=2;
 masTraekt[i].zrk=false;
 i++;
 };
 };// 
};

void rls::PTform()//  
{int i=0;
 while (i<masOtmetok.size())
    {if (masOtmetok[i].q) masOtmetok.erase(masOtmetok.begin()+i); else i++;
    };

 masFirstDot.resize(masOtmetok.size());
 for (i=0; i<masOtmetok.size(); i++)
   {masFirstDot[i].t0=masOtmetok[i].t;
    masFirstDot[i].x0=masOtmetok[i].x;
    masFirstDot[i].y0=masOtmetok[i].y;
    masFirstDot[i].z0=masOtmetok[i].z;
    masFirstDot[i].sigx=masOtmetok[i].sigx;
    masFirstDot[i].sigy=masOtmetok[i].sigy;
    masFirstDot[i].sigz=masOtmetok[i].sigz;
    masFirstDot[i].nmb = masOtmetok[i].nmb;
    masFirstDot[i].b = masOtmetok[i].b;
   };
};

void rls::TRZNACH()
{int i;
 double Ro;
 double K;
 double A,B,C;
 double dr;
 int dk;
 int Where;

 for (i=0; i<masTraekt.size(); i++)
    {if (masTraekt[i].length>4) {masTraekt[i].k=1;};
     if (masTraekt[i].b&&masTraekt[i].length>4)
                         {if (fabs(masTraekt[i].vx0)<1) {A=1; B=0;
                                                         C=masTraekt[i].x0;}
                                                   else {
                                K=masTraekt[i].vy0/masTraekt[i].vx0;
                                A = K;
                                B = -1;
                                C = masTraekt[i].y0 - K * masTraekt[i].x0;
                                                        };
                          Ro=fabs((A*objects[tt_IA_home].x+
                                   B*objects[tt_IA_home].y+C)/
                                   sqrt(A*A+B*B));
                          Where=tt_IA_home;

                          if (Ro >= fabs((A*objects[tt_ZRK_mon].x+
                                          B*objects[tt_ZRK_mon].y+C)/
                                          sqrt(A*A+B*B)
                                        )
                              )
                                     {Ro=fabs((A*objects[tt_ZRK_mon].x+
                                               B*objects[tt_ZRK_mon].y+C)/
                                               sqrt(A*A+B*B));
                                      Where=tt_ZRK_mon;
                                     };


                          if (Ro >= fabs((A*objects[tt_ZRK_mult].x+
                                          B*objects[tt_ZRK_mult].y+C)/
                                          sqrt(A*A+B*B)
                                        )
                              )
                                     {Ro=fabs((A*objects[tt_ZRK_mult].x+
                                               B*objects[tt_ZRK_mult].y+C)/
                                               sqrt(A*A+B*B));
                                      Where=tt_ZRK_mult;
                                     };


                          if (Ro >= fabs((A*objects[tt_RLS].x+
                                          B*objects[tt_RLS].y+C)/
                                          sqrt(A*A+B*B)
                                        )
                              )
                                     {Ro=fabs((A*objects[tt_RLS].x+
                                               B*objects[tt_RLS].y+C)/
                                               sqrt(A*A+B*B));
                                      Where=tt_RLS;
                                     };


                          if (Ro >= fabs((A*objects[tt_OBJ].x+
                                          B*objects[tt_OBJ].y+C)/
                                          sqrt(A*A+B*B)
                                        )
                              )
                                     {Ro=fabs((A*objects[tt_OBJ].x+
                                               B*objects[tt_OBJ].y+C)/
                                               sqrt(A*A+B*B));
                                      Where=tt_OBJ;
                                     };

                          masTraekt[i].k=attack_sopr+
                          (int)(4*(double)objects[Where].importance/
                                  (double)MaxIMPORT);
                          dr=sqrt((masTraekt[i].x0-objects[Where].x)*
                                  (masTraekt[i].x0-objects[Where].x)+
                                  (masTraekt[i].y0-objects[Where].y)*
                                  (masTraekt[i].y0-objects[Where].y));
                          dk=0;
                          if (dr<500.0) dk=1;//dest of objects
                          if (dr<100.0) dk=2;
                          if (dr<10.0)  dk=3;
                          if (dr<3.0)   dk=4;
                          masTraekt[i].k+=dk;
                          if (masTraekt[i].k<2) masTraekt[i].k=2;
                         };
    };
};

void rls::TRdel()// 
{
int i=0;
  while (i<masTraekt.size())
  {
        if((cur_time-masTraekt[i].t)>(2*PERIOD/SPEED_COEF) )
                masTraekt.erase(masTraekt.begin()+i);
        else i++;
  }
};

 rls::rls ()
 {randomize();
  masOtmetok.resize(0);
  masTraekt.resize(0);
  masFirstDot.resize(0);
  masFirstDot.reserve(100);
  masTraekt.reserve(100);
  masOtmetok.reserve(100);
//  
  PERIOD = current_rls.period; //period of our station in takts...
  HMin = current_rls.Hmin; //min h, where i see
  HMax = current_rls.Hmax; //max h, where i see
  vmin = current_attack_bomb.Vmin; //min v of enemy
  vmax = current_attack_bomb.Vmax; //max v of enemy
  LMax = current_rls.radius; //max length i see
  LMaxLow = current_rls.Lmaxlow; //max length i see on the hmin
  LMinHigh = current_rls.Lminhigh; //min length i see on the hmax

  HMinFar = current_rls.Hminfar; //min h that i see on the LMax
  EPS = current_rls.Eps; //my error

  zrk1x = objects[tt_ZRK_mon].x; //zr1 x and y
  zrk1y = objects[tt_ZRK_mon].y;
  zrk1r = current_zrk_mon.Lmax; //zrk1 radius
  zrk2x = objects[tt_ZRK_mult].x; //zrk2
  zrk2y = objects[tt_ZRK_mult].y;
  zrk2r = current_zrk_mult.Lmax;
  objx = objects[tt_OBJ].x;
  objy = objects[tt_OBJ].y;
  r_max_our_fire = current_defence_fighter.radius; //max our plane radius
  optimal_h_to_fly = current_defence_fighter.Hoptimal;
  MaxIMPORT=objects[tt_RLS].importance;
  if (MaxIMPORT<objects[tt_IA_home].importance)
      MaxIMPORT=objects[tt_IA_home].importance;
  if (MaxIMPORT<objects[tt_ZRK_mon].importance)
      MaxIMPORT=objects[tt_ZRK_mon].importance;
  if (MaxIMPORT<objects[tt_ZRK_mult].importance)
      MaxIMPORT=objects[tt_ZRK_mult].importance;
  if (MaxIMPORT<objects[tt_OBJ].importance)
      MaxIMPORT=objects[tt_OBJ].importance;
                                //optimul h to our plane fly

  rocket_zrk=2;
 };

  void rls::rls_init()
 {
 //   
 PERIOD = current_rls.period; //period of our station in takts...
 HMin = current_rls.Hmin; //min h, where i see
 HMax = current_rls.Hmax; //max h, where i see
 vmin = current_attack_bomb.Vmin; //min v of enemy
 vmax = current_attack_bomb.Vmax; //max v of enemy
 LMax = current_rls.radius; //max length i see
 LMaxLow = current_rls.Lmaxlow; //max length i see on the hmin
 LMinHigh = current_rls.Lminhigh; //min length i see on the hmax

 HMinFar = current_rls.Hminfar; //min h that i see on the LMax
 EPS = current_rls.Eps; //my error

 zrk1x = objects[tt_ZRK_mon].x; //zr1 x and y
 zrk1y = objects[tt_ZRK_mon].y;
 zrk1r = current_zrk_mon.Lmax; //zrk1 radius
 zrk2x = objects[tt_ZRK_mult].x; //srk2
 zrk2y = objects[tt_ZRK_mult].y;
 zrk2r = current_zrk_mult.Lmax;
 objx = objects[tt_OBJ].x;
 objy = objects[tt_OBJ].y;
 r_max_our_fire = 15; //max our plane radius
 optimal_h_to_fly = current_defence_fighter.Hoptimal;
                                //optimul h to our plane fly
  MaxIMPORT=objects[tt_RLS].importance;
  if (MaxIMPORT<objects[tt_IA_home].importance)
      MaxIMPORT=objects[tt_IA_home].importance;
  if (MaxIMPORT<objects[tt_ZRK_mon].importance)
      MaxIMPORT=objects[tt_ZRK_mon].importance;
  if (MaxIMPORT<objects[tt_ZRK_mult].importance)
      MaxIMPORT=objects[tt_ZRK_mult].importance;
  if (MaxIMPORT<objects[tt_OBJ].importance)
      MaxIMPORT=objects[tt_OBJ].importance;
 rocket_zrk=2;
 };

  void rls::one_takt()//       
 {MTform();
  Sglazh();
  KorrOtm();
  ZavTr();
  PTform();
  TRdel();
  TRZNACH();
  masZapZRK.resize(0);
 }

void rls::prnPT()
 {if(!masFirstDot.size()) {printf("Empty First Dot traekt\n"); return;};
  for (int i=0; i<masFirstDot.size(); i++)
      {printf ("%d First Dot with x = %f, y = %f, h = %f\n",i,masFirstDot[i].x0,
               masFirstDot[i].y0,masFirstDot[i].z0);
      };
   };

void rls::prnMO()
 {if(!masOtmetok.size()) {printf("Empty Arr Otmetok\n"); return;};
  for (int i=0; i<masOtmetok.size(); i++)
      {printf ("%d Otmetka with x = %f, y = %f, h = %f, q = %d\n",i,masOtmetok[i].x,
               masOtmetok[i].y,masOtmetok[i].z,masOtmetok[i].q);
      };
 };

 void rls::prntraekt()
 {if(!masTraekt.size()) {printf("Empty Arr traekt\n"); return;};
  for (int i=0; i<masTraekt.size(); i++)
      {printf ("%d Traekt (%f, %f, %f) with speed (%f, %f, %f)\n imp=%d. ",
               i,masTraekt[i].x0,masTraekt[i].y0,masTraekt[i].z0,
               masTraekt[i].vx0,masTraekt[i].vy0,masTraekt[i].vz0,
               masTraekt[i].k);
       if (masTraekt[i].b) printf ("It's a bomber.\n");
                      else printf ("It's a fighter.\n");
      };
 };

void rls::prn_i_traekt(int n)
 {if(n>=masTraekt.size()) {printf("too large n\n"); return;};
  printf ("%d Traekt (%f, %f, %f) with speed (%f, %f, %f)\n imp=%d. ",
             n,masTraekt[n].x0, masTraekt[n].y0, masTraekt[n].z0,
               masTraekt[n].vx0,masTraekt[n].vy0,masTraekt[n].vz0,
               masTraekt[n].k);
  if (masTraekt[n].b) printf ("It's a bomber.\n");
                 else printf ("It's a fighter.\n");
  };

bool rls::airport ()//  ,   
{ if (masTraekt.size()==0) return false;
  return true;
};

bool rls::boegot() {if(masTraekt.size()==0) return FALSE;
  					return true;};
 void rls::whereflyin(double Myx,double Myy,double Myz,double r,
                int n)
 { int i,j,leng1,leng,notzrk;
  int dk;
  double a,b,c,d,tx,ty,tz;
  double t_min,min_r2;
  leng=masTraekt.size();
  notzrk=0;
  for(i=0;i<leng;i++)
    if(!masTraekt[i].zrk) notzrk++;
  leng1=masimp.size();
  masimp.resize(leng1+1);
  masimp[leng1].x=Myx;
  masimp[leng1].y=Myy;
  masimp[leng1].z=Myz;
  masimp[leng1].r=r;
  masimp[leng1].n=n;
  masimp[leng1].izinbattle=false;
  masimp[leng1].imp=new int[notzrk];
  j=0;
  for(i=0;i<leng;i++)
  { if(masTraekt[i].zrk) continue;
    tx=masTraekt[i].x0;
    ty=masTraekt[i].y0;
    tz=masTraekt[i].z0;
    a=masTraekt[i].vx0;
    b=masTraekt[i].vy0;
    c=masTraekt[i].vz0;
    min_r2=(Myx-tx)*(Myx-tx)+(Myy-ty)*(Myy-ty)+(Myz-tz)*(Myz-tz);
     dk=0;
                          if (min_r2<100.0) dk=1;
                          if (min_r2<70.0) dk=2;
                          if (min_r2<10.0)  dk=3;
                          if (min_r2<3.0)   dk=4;
    masimp[leng1].imp[j]=masTraekt[i].k+dk;

    j++;
  }

}


void rls::whereflyout(masobstrel * m)
{ int i,j,l,leng,leng1,notzrk;
  int maxj,maxl,maxi,max,nmm;
  double myx,myy,myz,r,tx,ty,tz,a,b,c,d;
  double t_min,min_fly,min_r2;
  double takt;
  double epsilon = 2000;

  leng=masTraekt.size();
  leng1=masimp.size();
  notzrk=0;
  for(i=0;i<leng;i++)
    if(!masTraekt[i].zrk) notzrk++;
  max=0;

  nmm=0;

  //for(i=0;i<leng1;i++)
  //      printf(" %d",masimp[i].n);
  //printf("\n");
  for (;;)
  { max=0;
    maxj=maxl=maxi=0;
    j=0;
    for(i=0;i<leng;i++)
      { if(masTraekt[i].zrk) continue;
        j++;
        if(masTraekt[i].k==0) continue;
        for(l=leng1-1;l>=0;l--)
          {
          if(masimp[l].izinbattle) continue;
            if(masimp[l].imp[j-1]<max) continue;
            max=masimp[l].imp[j-1];
            maxj=j-1;
            maxi=i;
            maxl=l;
          }
      } //end for with i
    if(max==0) break;
    l=maxl;
    i=maxi;
    masimp[l].izinbattle=true;
    m[nmm].number=masimp[l].n;
    m[nmm].nmb=masTraekt[i].nmb;
    myx=masimp[l].x;
    myy=masimp[l].y;
    myz=masimp[l].z;
    tx=masTraekt[i].x0;
    ty=masTraekt[i].y0;
    tz=masTraekt[i].z0;
    a=masTraekt[i].vx0;
    b=masTraekt[i].vy0;
    c=masTraekt[i].vz0;
    min_r2=(myx-tx)*(myx-tx)+(myy-ty)*(myy-ty)+(myz-tz)*(myz-tz);
    if(min_r2<(r_max_our_fire*r_max_our_fire))
      { takt=cur_time-masTraekt[i].t;
        m[nmm].x=masTraekt[i].x0+takt*a;
        m[nmm].y=masTraekt[i].y0+takt*b;
        m[nmm].z=masTraekt[i].z0+takt*c;
        m[nmm].flagfly=false;
        nmm++;
        for(j=0;j<leng1;j++)
            masimp[j].imp[maxj]--;
        masTraekt[i].k--;
        continue;
      }
    t_min=(a*(myx-tx)+b*(myy-ty)+c*(myz-tz))/(a*a+b*b+c*c);
    min_fly=(tx+a*t_min-myx)*(tx+a*t_min-myx)+(ty+b*t_min-myy)* \
            (ty+b*t_min-myy)+(tz+c*t_min-myz)*(tz+c*t_min-myz);

    m[nmm].flagfly=true;
    if(min_fly<epsilon*epsilon)
      { takt=cur_time-masTraekt[i].t;
        m[nmm].x=tx+a*takt;
        m[nmm].y=ty+b*takt;
        m[nmm].z=tz+c*takt;
        nmm++;
        masTraekt[i].k--;
        continue;
      }
    if(min_fly<masimp[l].r*masimp[l].r)
      { m[nmm].x=tx+a*t_min;
        m[nmm].y=ty+b*t_min;
        m[nmm].z=tz+c*t_min;
        nmm++;
        for(j=0;j<leng1;j++)
            masimp[j].imp[maxj]--;
        masTraekt[i].k--;
        continue;
      }
    m[nmm].nmb=-1;
    m[nmm].x=0;
    m[nmm].y=0;
    m[nmm].z=optimal_h_to_fly;
    a=myx*myx+myy*myy;
    b=(myx-zrk1x)*(myx-zrk1x)+(myy-zrk1y)*(myy-zrk1y);
    c=(myx-zrk2x)*(myx-zrk2x)+(myy-zrk2y)*(myy-zrk2y);
    d=(myx-objx)*(myx-objx)+(myy-objy)*(myy-objy);

    if((a<=b)&&(b<=c)&&(b<=d)||(c<=b)&&(b<=a)&&(b<=d)||(d<=b)&&(b<=a)&&(b<=c))
    {m[nmm].x=zrk1x;
     m[nmm].y=zrk1y;
    }
    if((a<=c)&&(c<=b)&&(c<=d)||(b<=c)&&(c<=a)&&(c<=d)||(d<=c)&&(c<=a)&&(c<=b))
    {m[nmm].x=zrk1x;
     m[nmm].y=zrk1y;
    }
    if((a<=d)&&(d<=b)&&(d<=c)||(b<=d)&&(d<=a)&&(d<=c)||(c<=d)&&(d<=a)&&(d<=b))
      {m[nmm].x=objx;
       m[nmm].y=objy;
      }
    nmm++;
  }
  for(i=0;i<leng1;i++)
  { if(masimp[i].izinbattle) continue;


 m[nmm].flagfly=true;
    m[nmm].nmb=-1;
    m[nmm].number=masimp[i].n;
    m[nmm].x=0;
    m[nmm].y=0;
    m[nmm].z=optimal_h_to_fly;

    myx=masimp[i].x;
    myy=masimp[i].y;
    myz=masimp[i].z;
    a=myx*myx+myy*myy;
    b=(myx-zrk1x)*(myx-zrk1x)+(myy-zrk1y)*(myy-zrk1y);
    c=(myx-zrk2x)*(myx-zrk2x)+(myy-zrk2y)*(myy-zrk2y);
    d=(myx-objx)*(myx-objx)+(myy-objy)*(myy-objy);

    if((a<=b)&&(b<=c)&&(b<=d)||(c<=b)&&(b<=a)&&(b<=d)||(d<=b)&&(b<=a)&&(b<=c))
    {m[nmm].x=zrk1x;
     m[nmm].y=zrk1y;
    }
    if((a<=c)&&(c<=b)&&(c<=d)||(b<=c)&&(c<=a)&&(c<=d)||(d<=c)&&(c<=a)&&(c<=b))
    {m[nmm].x=zrk1x;
     m[nmm].y=zrk1y;
    }
    if((a<=d)&&(d<=b)&&(d<=c)||(b<=d)&&(d<=a)&&(d<=c)||(c<=d)&&(d<=a)&&(d<=b))
      {m[nmm].x=objx;
       m[nmm].y=objy;
      }
    nmm++;
  }

  masimp.resize(0);

};


bool rls::wherefly(double Myx,double Myy,double Myh,
              double r,
              double &x,double &y,double &h,
              int &n)//  ,  
{ int leng,i;
  int min_n;
  int min_n_o;
  double min_r2,min_r2_i,min_fly,min_fly_i ,t_min;
  double a,b,c,d,tx,ty,tz;
  double takt;
  int vazh;
  bool flag_fly;
  double epsilon = 500;


  leng=masTraekt.size();
  for(int j=0;(leng!=0)&&(j==0);j++)
  { tx=masTraekt[0].x0;
    ty=masTraekt[0].y0;
    tz=masTraekt[0].z0;
    min_r2=(Myx-tx)*(Myx-tx)+(Myy-ty)*(Myy-ty)+(Myh-tz)*(Myh-tz);
    min_n=masTraekt[0].nmb;
    min_n_o=0;
    for(i=1; i<leng; i++)
      { tx=masTraekt[i].x0;
        ty=masTraekt[i].y0;
        tz=masTraekt[i].z0;
        min_r2_i=(Myx-tx)*(Myx-tx)+(Myy-ty)*(Myy-ty)+(Myh-tz)*(Myh-tz);
        if(min_r2>min_r2_i) { min_r2=min_r2_i;min_n=masTraekt[i].nmb;min_n_o=i;}

      }

    if(min_r2<(r_max_our_fire*r_max_our_fire))
      { //takt=cur_time-masTraekt[min_n].t;    .
        takt=cur_time-masTraekt[min_n_o].t;
        x=masTraekt[min_n_o].x0+takt*masTraekt[min_n_o].vx0;
        y=masTraekt[min_n_o].y0+takt*masTraekt[min_n_o].vy0;
        h=masTraekt[min_n_o].z0+takt*masTraekt[min_n_o].vz0;
        return FALSE;
      }

    if(n!=-1) //what is it?
      { for (i=0; i<masTraekt.size(); i++)
         {if (masTraekt[i].nmb==n) break;};
        if(i!=masTraekt.size())       //what is it?
         { tx=masTraekt[i].x0;
           ty=masTraekt[i].y0;
           tz=masTraekt[i].z0;
           a=masTraekt[i].vx0;
           b=masTraekt[i].vy0;
           c=masTraekt[i].vz0;
           t_min=(a*(Myx-tx)+b*(Myx-tx)+c*(Myx-tx))/(a*a+b*b+c*c);
           min_fly=(tx+a*t_min-Myx)*(tx+a*t_min-Myx)+(ty+b*t_min-Myy)*
                   (ty+b*t_min-Myy)+(tz+c*t_min-Myh)*(tz+c*t_min-Myh);
           if(min_fly<epsilon*epsilon) //!!!!!!!!!!!!!!!!epsilon=10metrov!!!!!!!!!!!!!!!!
            { takt=cur_time-masTraekt[i].t; ///why n???!!!
              x=tx+a*takt;
              y=ty+b*takt;
              h=tz+c*takt;
              return TRUE;
            }
           if(min_fly<r*r)
            { x=tx+a*t_min;
              y=ty+b*t_min;
              h=tz+c*t_min;
              return TRUE;
            }
         }
      }

   flag_fly=false; //added for next string
    for(i=0;(i<leng)&&(!flag_fly);i++) //flag_fly not defined
     { if((masTraekt[i].k!=0)&&(masTraekt[i].b))
       vazh=masTraekt[i].k;
       tx=masTraekt[i].x0;
       ty=masTraekt[i].y0;
       tz=masTraekt[i].z0;
       a=masTraekt[i].vx0;
       b=masTraekt[i].vy0;
       c=masTraekt[i].vz0;
       t_min=(a*(Myx-tx)+b*(Myx-tx)+c*(Myx-tx))/(a*a+b*b+c*c);
       min_fly=(tx+a*t_min-Myx)*(tx+a*t_min-Myx)+(ty+b*t_min-Myy)*
               (ty+b*t_min-Myy)+(tz+c*t_min-Myh)*(tz+c*t_min-Myh);
       if(min_fly<r*r) {flag_fly=true;min_n=i;};
     };
    for(;i<leng;i++) //strange step!!!!!!
    { if((masTraekt[i].k>=vazh)&&(masTraekt[i].b))
      { tx=masTraekt[i].x0;
        ty=masTraekt[i].y0;
        tz=masTraekt[i].z0;
        a=masTraekt[i].vx0;
        b=masTraekt[i].vy0;
        c=masTraekt[i].vz0;
        t_min=(a*(Myx-tx)+b*(Myx-tx)+c*(Myx-tx))/(a*a+b*b+c*c);
        min_fly_i=(tx+a*t_min-Myx)*(tx+a*t_min-Myx)+(ty+b*t_min-Myy)*
        	  (ty+b*t_min-Myy)+(tz+c*t_min-Myh)*(tz+c*t_min-Myh);
        if(min_fly_i<r*r) {flag_fly=true;min_n=i;vazh=masTraekt[i].k;}
      };
    };
    if(flag_fly)
    {
     tx=masTraekt[min_n].x0;
     ty=masTraekt[min_n].y0;
     tz=masTraekt[min_n].z0;
     a=masTraekt[min_n].vx0;
     b=masTraekt[min_n].vy0;
     c=masTraekt[min_n].vz0;
     t_min=(a*(Myx-tx)+b*(Myx-tx)+c*(Myx-tx))/(a*a+b*b+c*c);
     x=tx+a*t_min;
     y=ty+b*t_min;
     h=tz+c*t_min;
     n=masTraekt[min_n].nmb;
     masTraekt[min_n].k--;
     return TRUE;
    }
  }
    n=-1;
    x=0;
    y=0;
    h=optimal_h_to_fly;
    a=Myx*Myx+Myy*Myy;
    b=(Myx-zrk1x)*(Myx-zrk1x)+(Myy-zrk1y)*(Myy-zrk1y);
    c=(Myx-zrk2x)*(Myx-zrk2x)+(Myy-zrk2y)*(Myy-zrk2y);
    d=(Myx-objx)*(Myx-objx)+(Myy-objy)*(Myy-objy);

    if((a<=b)&&(b<=c)&&(b<=d)||(c<=b)&&(b<=a)&&(b<=d)||(d<=b)&&(b<=a)&&(b<=c))
    {x=zrk1x;
     y=zrk1y;
    }
    if((a<=c)&&(c<=b)&&(c<=d)||(b<=c)&&(c<=a)&&(c<=d)||(d<=c)&&(c<=a)&&(c<=b))
    {x=zrk1x;
     y=zrk1y;
    }
    if((a<=d)&&(d<=b)&&(d<=c)||(b<=d)&&(d<=a)&&(d<=c)||(c<=d)&&(d<=a)&&(d<=b))
      {x=objx;
       y=objy;
      };
    return TRUE;
}


void rls::getkoordzrk(int Numb, double &x, double &y, double &r,double &VmaxR ) //  ,  
//0 - zrk_mon
//1 - zrk_mult
{if(Numb==0){x=zrk1x;y=zrk1y;r=zrk1r; VmaxR=current_zrk_mon.Vmax;}
 else {x=zrk2x;y=zrk2y;r=zrk2r; VmaxR=current_zrk_mult.Vmax;};
 return;
}


void rls::firein (int n)
  {int i=masZapZRK.size();
   masZapZRK.resize(i+1);
   masZapZRK[i]=n;
  };

double rls::get_t(double x,  double y,  double z,
             double vx, double vy, double vz,
             double x0, double y0, double z0,
             double Vm)
    {double rx,ry,rz,rr1,rr2;
     double A = vx*vx+vy*vy+vz*vz-Vm*Vm;
     double B = 2*(vx*(x-x0)+vy*(y-y0)+vz*(z-z0));
     double C = (x-x0)*(x-x0)+(y-y0)*(y-y0)+(z-z0)*(z-z0);

     double D = B*B-4*A*C;
     if (D<0) return -1;

     double t1=(-B+sqrt(D))/(2*A);
     double t2=(-B-sqrt(D))/(2*A);

     if (t1<=0) t1=t2;
     if (t1<=0) return -1;
     rx = x+vx*t1; ry = y+vy*t1;  rz = z+vz*t1;
     rr1 = sqrt((rx-x0)*(rx-x0)+(ry-y0)*(ry-y0)+(rz-z0)*(rz-z0));
     if (t2>=0) {
     rx = x+vx*t2; ry = y+vy*t2;  rz = z+vz*t2;
     rr2 = sqrt((rx-x0)*(rx-x0)+(ry-y0)*(ry-y0)+(rz-z0)*(rz-z0));
     if (fabs((rr1/t1)-Vm)<fabs((rr2/t2)-Vm)) return t1; else return t2;
                } else
                {return t1;};

    };


void rls::fireout (struct masobstrel1 * m)
  {int i,j,n;
   double t;
   double xz,yz,rz,VmaxR;
   double xe,ye,ze;
   vector<Vint> matr;
   int maxz;

   matr.resize(masZapZRK.size());//matrix size
   for (i=0; i<matr.size(); i++) {matr[i].resize(masTraekt.size());};//line size

   for (i=0; i<masZapZRK.size(); i++)
       {getkoordzrk (masZapZRK[i],xz,yz,rz,VmaxR);
        for (j=0; j<masTraekt.size(); j++)
             {t=get_t(masTraekt[j].x0,masTraekt[j].y0,masTraekt[j].z0,
                      masTraekt[j].vx0,masTraekt[j].vy0,masTraekt[j].vz0,
                      xz,yz,0,VmaxR);
              if ((t<0)||(masTraekt[j].zrk))
                     {matr[i][j].k=0; matr[i][j].nzrk=masZapZRK[i];}
                     else
                     {
              xe = masTraekt[j].x0 + t*masTraekt[j].vx0;
              ye = masTraekt[j].y0 + t*masTraekt[j].vy0;
              ze = masTraekt[j].z0 + t*masTraekt[j].vz0;
              if ((((xe-xz)*(xe-xz)+(ye-yz)*(ye-yz))<rz*rz)&&
                    (attack_vector_air[masTraekt[j].nmb].life!=0)&&
                    (!masTraekt[j].zrk)
                     )
                   {matr[i][j].nzrk=masZapZRK[i];
                    matr[i][j].nmb=masTraekt[j].nmb;
                    matr[i][j].k=masTraekt[j].k;
                    matr[i][j].x=xe;
                    matr[i][j].y=ye;
                    matr[i][j].z=ze;
                    matr[i][j].t=t;
                    matr[i][j].tr=j;
                   }
                   else
                   {matr[i][j].k=0;
                    matr[i][j].nzrk=masZapZRK[i];
                   };
                     };
             };
       };

   j=0;
   while (matr.size())
        {maxz=0;
         i=0;
         n=-1;
         while (i<matr[0].size())
           {if (maxz<matr[0][i].k) {maxz=matr[0][i].k;n=i;};
            i++;
           };
         if (n>=0) {m[j].x=matr[0][n].x;
                    m[j].y=matr[0][n].y;
                    m[j].z=matr[0][n].z;
                    m[j].t=matr[0][n].t;
                    m[j].numb=matr[0][n].nmb;
                    masTraekt[matr[0][n].tr].zrk=true;
                    m[j].nzrk=matr[0][n].nzrk;
           			  for (i=0; i<matr.size(); i++)
                                 {matr[i].erase(matr[i].begin()+n);};
                   } else m[j].numb=-1;
         matr.erase(matr.begin());
         j++;
        };
  };

bool rls::is_view (int n)
   {for (int i=0; i<masTraekt.size(); i++)
         {if (is_seen (attack_vector_air[n].x,
                       attack_vector_air[n].y,
                       attack_vector_air[n].h)
                       &&((masTraekt[i].length>4)||
               (masTraekt[i].length==2)
              )&&(masTraekt[i].nmb==n)
              ) return true;};
   return false;
   };

int rls::where_view (int n)
   {for (int i=0; i<masTraekt.size(); i++)
         {if (masTraekt[i].nmb==n) return i;};
   return -1;
   };


void rls::killairzrk (int n)// .       ,
//   .
   {for (int i=0; i<masTraekt.size(); i++)
         {if (masTraekt[i].nmb==n) masTraekt[i].zrk=false;};
   };

void rls::killair (int n)// .       ,
//   .
 {
    for (int i=0; i<masTraekt.size(); i++)
    {
    if (masTraekt[i].nmb==n) {masTraekt[i].k++;};
    };
 };

