#include "zrk.h"

static int RandomNumber = 0xffff;
struct masobstrel1 *m;

TZRK::TZRK()
{
        Channels = new Channel[MAX_CHANNELS];
}

TZRK::~TZRK()
{
        delete [] Channels;
}

TZRK ZRK1,ZRK2;

float Random()
{
        RandomNumber = (25173 * RandomNumber + 13849) % (Modul);
        return (float)RandomNumber / (Modul);
}

//

void zrk_init()
{
        // 
        int i;
        double d=current_zrk_mult.Lmax;
        // -300
        ZRK1.disposition.x= objects[tt_ZRK_mult].x;
        ZRK1.disposition.y= objects[tt_ZRK_mult].y;
        ZRK1.max_rockets  = current_zrk_mult.Capacity;       //2 
        ZRK1.maxD         = current_zrk_mult.Lmax;
        ZRK1.minD         = current_zrk_mult.Lmin;
        ZRK1.maxH         = current_zrk_mult.Hmax;
        ZRK1.minH         = current_zrk_mult.Hmin;
        ZRK1.num_channels = current_zrk_mult.Rock_Chan;
        ZRK1.rocketV      = current_zrk_mult.Vmax;
        ZRK1.rocketR      = current_zrk_mult.D_radius;
        ZRK1.sigma        = 0.003;
        ZRK1.p_kill       = current_zrk_mult.Pr;
        ZRK1.free_channels= ZRK1.num_channels;
        ZRK1.used_rockets = 0;

        for (i=0; i<ZRK1.num_channels; i++)
                ZRK1.Channels[i].free_channel= true;

        // -125
        ZRK2.disposition.x= objects[tt_ZRK_mon].x;
        ZRK2.disposition.y= objects[tt_ZRK_mon].y;
        ZRK2.max_rockets  = current_zrk_mon.Capacity;
        ZRK2.maxD         = current_zrk_mon.Lmax;
        ZRK2.minD         = current_zrk_mon.Lmin;
        ZRK2.maxH         = current_zrk_mon.Hmax;
        ZRK2.minH         = current_zrk_mon.Hmin;
        ZRK2.num_channels = current_zrk_mon.Rock_Chan;
        ZRK2.rocketV      = current_zrk_mon.Vmax;
        ZRK2.rocketR      = current_zrk_mon.D_radius;
        ZRK2.sigma        = 0.003;
        ZRK2.p_kill       = current_zrk_mon.Pr;
        ZRK2.free_channels= ZRK2.num_channels;
        ZRK2.used_rockets = 0;

        for (i=0; i<ZRK2.num_channels; i++)
                ZRK2.Channels[i].free_channel= true;
}
/*
bool IsDefeatZone(int Numb, Vector3D pos)
{
//
float D;

if (Numb==1)
{
D= sqrt((pos.x-ZRK1.disposition.x)*(pos.x-ZRK1.disposition.x)+(pos.y-ZRK1.disposition.y)*(pos.y-ZRK1.disposition.y));
if ((ZRK1.minH<pos.z&&pos.z<ZRK1.maxH)&&(ZRK1.minD<D&&D<ZRK1.maxD)) return true;
}
else
{
D= sqrt((pos.x-ZRK2.disposition.x)*(pos.x-ZRK2.disposition.x)+(pos.y-ZRK2.disposition.y)*(pos.y-ZRK2.disposition.y));
if ((ZRK2.minH<pos.z&&pos.z<ZRK2.maxH)&&(ZRK2.minD<D&&D<ZRK2.maxD)) return true;
}
return false;
}
*/
void GetRocketSpeed(Vector3D rpos, Vector3D bpos, float rspeed,Vector3D& rocket_speed)
{
        float len;
        len=sqrt((rpos.x-bpos.x)*(rpos.x-bpos.x)+(rpos.y-bpos.y)*(rpos.y-bpos.y)+(rpos.z-bpos.z)*(rpos.z-bpos.z));
        if( len != 0 )
        {
                rocket_speed.x=(bpos.x-rpos.x)*rspeed/len;
                rocket_speed.y=(bpos.y-rpos.y)*rspeed/len;
                rocket_speed.z=(bpos.z-rpos.z)*rspeed/len;
        }
        else
        {
                rocket_speed.x=0;
                rocket_speed.y=0;
                rocket_speed.z=0;
        }
}
//

void shot()
{
        //  
        int i;
        int k;
        int ind;

        //    fire  
        int   n;
        float x, y, h;

        Vector3D pos;
        Vector3D speed;
        Vector3D rocket_speed;

        ind=0;
        for (i=0; i<ZRK1.num_channels; i++)
                if (ZRK1.Channels[i].free_channel && current_zrk_mult.Capacity>0)
                {
                        ind=ind+1;
                        rls_var.firein(1);
                }

        for (i=0; i<ZRK2.num_channels; i++)
                if (ZRK2.Channels[i].free_channel && current_zrk_mon.Capacity>0)
                {
                        ind=ind+1;
                        rls_var.firein(0);
                }

        //     
        //   
      if(current_zrk_mult.Capacity>0)
        for (i=0; i<ZRK1.num_channels ; i++)
        {
                if (!(ZRK1.Channels[i].free_channel))
                {// 
	                if (cur_time>ZRK1.Channels[i].btime)
	                {
                                current_zrk_mult.Capacity--;
                                ZRK1.Channels[i].pos_rocket.x = 0;
                                ZRK1.Channels[i].pos_rocket.y = 0;
                                ZRK1.Channels[i].pos_rocket.z = 0;
                                if (ZRK1.p_kill>Random())
	                        {//
	                                ZRK1.free_channels++;
                                        ZRK1.Channels[i].free_channel=true;
	                                rls_var.killairzrk(ZRK1.Channels[i].n);
                                        attack_vector_air[ZRK1.Channels[i].n].life=0;
                                        //Aim killed
	                        }
                                else
	                        {// 
                                        ZRK1.free_channels++;
                                        ZRK1.Channels[i].free_channel=true;
                                        rls_var.killairzrk(ZRK1.Channels[i].n);
	                        }
	                }
                        else
	                {//   
	                        ZRK1.Channels[i].pos_rocket.x+= ZRK1.Channels[i].rocket_speed.x*dt;
                                ZRK1.Channels[i].pos_rocket.y+= ZRK1.Channels[i].rocket_speed.y*dt;
                                ZRK1.Channels[i].pos_rocket.z+= ZRK1.Channels[i].rocket_speed.z*dt;
	                }
                }
        }

       if(current_zrk_mon.Capacity>0)
        for (i=0; i<ZRK2.num_channels; i++)
        {
                if (!(ZRK2.Channels[i].free_channel))
                {// 
	                if (cur_time>ZRK2.Channels[i].btime)
                        {
                                current_zrk_mon.Capacity--;
                                ZRK2.Channels[i].pos_rocket.x = 0;
                                ZRK2.Channels[i].pos_rocket.y = 0;
                                ZRK2.Channels[i].pos_rocket.z = 0;
                                if (ZRK2.p_kill>Random())
	                        {//
	                                ZRK2.free_channels++;
                                        ZRK2.Channels[i].free_channel=true;
	                                rls_var.killairzrk(ZRK2.Channels[i].n);
                                        attack_vector_air[ZRK2.Channels[i].n].life=0;
                                //Aim killed
	                        }
                                else
	                        {// 
                                        ZRK2.free_channels++;
                                        ZRK2.Channels[i].free_channel=true;
                                        rls_var.killairzrk(ZRK2.Channels[i].n);
	                        }
                        }
                        else
	                {//   
	                        ZRK2.Channels[i].pos_rocket.x+= ZRK2.Channels[i].rocket_speed.x*dt;
                                ZRK2.Channels[i].pos_rocket.y+= ZRK2.Channels[i].rocket_speed.y*dt;
                                ZRK2.Channels[i].pos_rocket.z+= ZRK2.Channels[i].rocket_speed.z*dt;
	                }
                 }
        }


        m = new masobstrel1[ind];
        rls_var.fireout(m);

        for(i=0; i<ind; i++)
        {
                if( m[i].numb < 0 ) continue;
                if (m[i].nzrk==1)
                {
                        for(k=0; !(ZRK1.Channels[k].free_channel) && k < ZRK1.num_channels;k++);
                        if( k != ZRK1.num_channels )
                        {
                                pos.x = m[i].x;
                                pos.y = m[i].y;
                                pos.z = m[i].z;
                                ZRK1.Channels[k].n = m[i].numb;
                                ZRK1.Channels[k].btime = m[i].t + cur_time;
                                ZRK1.Channels[k].pos_rocket.x = ZRK1.disposition.x;
                                ZRK1.Channels[k].pos_rocket.y = ZRK1.disposition.y;
                                ZRK1.Channels[k].pos_rocket.z = 0;
                                GetRocketSpeed(ZRK1.Channels[k].pos_rocket, pos, ZRK1.rocketV, ZRK1.Channels[k].rocket_speed);
                                ZRK1.Channels[k].free_channel = false;
                        }
                }
                else if (m[i].nzrk==0)
                {
                        for(k=0; !(ZRK2.Channels[k].free_channel) && k < ZRK2.num_channels;k++);
                        if( k != ZRK2.num_channels )
                        {
                                pos.x= m[i].x;
                                pos.y= m[i].y;
                                pos.z= m[i].z;
                                ZRK2.Channels[k].n= m[i].numb;
                                ZRK2.Channels[k].btime= m[i].t+ cur_time;
                                ZRK2.Channels[k].pos_rocket.x= ZRK2.disposition.x;
                                ZRK2.Channels[k].pos_rocket.y= ZRK2.disposition.y;
                                ZRK2.Channels[k].pos_rocket.z= 0;
                                GetRocketSpeed(ZRK2.Channels[k].pos_rocket, pos, ZRK2.rocketV, ZRK2.Channels[k].rocket_speed);
                                ZRK2.Channels[k].free_channel=false;
                        }
                }
        }

        delete [] m;
}
